;{ window
; Shortcut
Procedure AddKeyboardShortcutMenu()
  AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Pad7,44)
  AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Pad1,46)
  AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Pad3,48)
  AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Pad0,50)
  AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Pad9,51)
  ; object
  AddKeyboardShortcut(#WindowMain,#PB_Shortcut_H,358)
  AddKeyboardShortcut(#WindowMain,#PB_Shortcut_A,303)
  AddKeyboardShortcut(#WindowMain,#PB_Shortcut_L,304)
  AddKeyboardShortcut(#WindowMain,#PB_Shortcut_1,305)
  AddKeyboardShortcut(#WindowMain,#PB_Shortcut_2,306)
  AddKeyboardShortcut(#WindowMain,#PB_Shortcut_C,319)
  AddKeyboardShortcut(#WindowMain,#PB_Shortcut_P,320)
EndProcedure
Procedure RemoveShortcut()
  RemoveKeyboardShortcut(#WindowMain,#PB_Shortcut_Pad7)
  RemoveKeyboardShortcut(#WindowMain,#PB_Shortcut_Pad1)
  RemoveKeyboardShortcut(#WindowMain,#PB_Shortcut_Pad3)
  RemoveKeyboardShortcut(#WindowMain,#PB_Shortcut_Pad0)
  RemoveKeyboardShortcut(#WindowMain,#PB_Shortcut_Pad9)
  ; object
  RemoveKeyboardShortcut(#WindowMain,#PB_Shortcut_H)
  RemoveKeyboardShortcut(#WindowMain,#PB_Shortcut_A)
  RemoveKeyboardShortcut(#WindowMain,#PB_Shortcut_L)
  RemoveKeyboardShortcut(#WindowMain,#PB_Shortcut_1)
  RemoveKeyboardShortcut(#WindowMain,#PB_Shortcut_2)
  RemoveKeyboardShortcut(#WindowMain,#PB_Shortcut_C)
  RemoveKeyboardShortcut(#WindowMain,#PB_Shortcut_P)
EndProcedure

; Gadget Action
Procedure GadgetAction(action=0)
  ; hide the gadget
  HideGadget(#Gadget_ActionMapArrivee,1)
  HideGadget(#Gadget_ActionMapArriveePosX,1)
  HideGadget(#Gadget_ActionMapArriveePosY,1)
  HideGadget(#Gadget_ActionMapArriveePosZ,1)
  ; show the gadget by action
  Select action
    Case 0 ; pnj
      
    Case 1 ; teleporter
      HideGadget(#Gadget_ActionMapArrivee,0)
      HideGadget(#Gadget_ActionMapArriveePosX,0)
      HideGadget(#Gadget_ActionMapArriveePosY,0)
      HideGadget(#Gadget_ActionMapArriveePosZ,0)
    Case 2 ; coffre
      
    Case 3 ; block
      
    Case 4 ; objet dplaable
      
    Case 5 ; sauvegarder ou autre
      
    Case 6 ; fontaine (vie, mana..)
      
    Case 7 ; event de mob
      
  EndSelect
EndProcedure
IncludePath ""
XIncludeFile "include\lib\Lib_PropertyBox.pb"
XIncludeFile "include\procedures\ase3d_newUi.pb"

; toolbar
Procedure ToolBarPlusCallback(Window, message, wParam, lParam)
  ; toolbarplus is made by Eddy, thanks !
   Protected Result=#PB_ProcessPureBasicEvents
   ;
   ; your code
   ;
   ; ===============================================
   ; Enable automatic popup menu
   ; ===============================================
   
   Result=ToolBarPlusCB(Window, message, wParam, lParam, Result)
   
   ; ===============================================
   ; custom popup menu (without using SetToolbarMenu)
   ; ===============================================
   
   If ToolbarPlusCB_Toolbar()=ToolBarID(#TOOLBAR)
      If ToolbarPlusCB_ButtonID()=11 And ToolbarPlusCB_PressedArrow()=#False
         Protected owner=ToolbarPlusCB_Toolbar()
         Protected x=ToolbarPlusCB_PopupX()
         Protected y=ToolbarPlusCB_PopupY()
         DisplayPopupMenu(100, owner, x, y)
         ProcedureReturn 1
      EndIf
   EndIf
   
   ;
   ;
   ; your code
   ;
   
   ProcedureReturn Result
   
EndProcedure


; Main Window
Procedure OpenMainWindow()
If option\autosize
  flag= #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget|#PB_Window_Maximize
Else
  flag= #PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_MaximizeGadget|#PB_Window_MinimizeGadget
EndIf
  If OpenWindow(#WindowMain, 0, 0, option\WinW, option\WinH, "Arkeos Scene Editor 3D (Ase3D) - Version "+Version$+" [ ]", flag)
    UsePNGImageDecoder()
    ;{ images
    CatchImage(#Assets,?ImgAsset)
    CatchImage(#PNJ,?ImgPnj)
    CatchImage(#LightDyn,?ImgLightDyn)
    CatchImage(#Lightstatic,?ImgLightStat)
    CatchImage(#action,?ImgAction)
    CatchImage(#Effects,?ImgEffects)
    CatchImage(#Drop,?ImgDrop)
    CatchImage(#Obj_Move,?ImgObj_Move)
    CatchImage(#Obj_Block,?ImgObj_Block)
    CatchImage(#Obj_Destroy,?ImgObj_Destroy)
    CatchImage(#Camera,?ImgCamera)
    CatchImage(#Fontain,?ImgFontain)
    CatchImage(#FX,?ImgFX)
    ; toolbar
    LoadImage(#ToolbarImg0,"data\ui\move.ico") 
    LoadImage(#ToolbarImg1,"data\ui\rotate.ico") 
    LoadImage(#ToolbarImg2,"data\ui\scale.ico") 
    LoadImage(#ToolbarImg3,"data\ui\snap.ico") 
    LoadImage(#ToolbarImg4,"data\ui\tool_light.png") 
    ; for property light
    CreateImage(#lightcolordif,15,15)
    CreateImage(#lightcolorspec,15,15)

    ;}
    ;{ add menu
    CreateImageMenu(#MenuMain, WindowID(#WindowMain),#PB_Menu_ModernLook)
    MenuTitle("File"); 0 -> 40
    MenuItem(#menu_file_new,"New Scene"+Chr(9)+"(Ctrl+N)")
    MenuItem(#menu_file_clear,"Clear Scene")
    MenuBar()
    MenuItem(#menu_file_open,"Open Scene"+Chr(9)+"(Ctrl+O)")
    MenuItem(#menu_file_import,"Import Scene"+Chr(9)+"(Ctrl+I)")
    MenuItem(#menu_file_importscene,"Import Scene as")
    DisableMenuItem(0,#menu_file_importscene,1)
    MenuBar()
    MenuItem(#menu_file_save,"Save Scene"+Chr(9)+"(Ctrl+S)")
    MenuItem(#menu_file_saveas,"Save Scene as ..."+Chr(9)+"(Ctrl+AltS)")  
    MenuItem(#menu_file_saveselectedobj,"Save Selected Object"+Chr(9)+"(Ctrl+Shift+S)") 
    MenuBar()
    MenuItem(#menu_file_exportlevelforgame,"Export Level (For game)") 
    MenuItem(#menu_file_exportscene,"Export Scene as ...") 
    DisableMenuItem(0,#menu_file_exportlevelforgame,1)
    MenuBar()
    MenuItem(#menu_file_exit, "Quit"+Chr(9)+"(Esc)") 
    
    MenuTitle("Object");301-> 350
    OpenSubMenu("Type object")
    MenuItem(305,"Object3D"+Chr(9)+"(1)")
    MenuItem(306,"Light"+Chr(9)+"(2)")
    MenuItem(307,"Particles"+Chr(9)+"(3)")
    MenuItem(308,"Terrain"+Chr(9)+"(4)")
    MenuItem(309,"Water"+Chr(9)+"(5)")
    MenuItem(310,"Camera"+Chr(9)+"(6)")
    CloseSubMenu()
    OpenSubMenu("Object")    
    MenuItem(100,"Assets",ImageID(#Assets))
    MenuItem(101,"PNJ",ImageID(#PNJ))  
    MenuBar()
    MenuItem(102,"Light Dyn",ImageID(#LightDyn))
    MenuItem(103,"Light Stat",ImageID(#Lightstatic))  
    MenuBar()
    MenuItem(104,"Effects",ImageID(#Effects))
    MenuItem(108,"Fx",ImageID(#FX))
    MenuBar()
    MenuItem(105,"Add Actions",ImageID(#action))
    MenuItem(106,"Add Fontain",ImageID(#Fontain))
    MenuItem(107,"Add Drop",ImageID(#Drop))
    MenuBar()
    MenuItem(109,"Add Object Blocking",ImageID(#Obj_Block))
    MenuItem(110,"Add Object To Move",ImageID(#Obj_Move))
    MenuItem(111,"Add Object to destroy",ImageID(#Obj_Destroy))
    MenuBar()
    MenuItem(112,"Add Camera",ImageID(#Camera))    
    CloseSubMenu()
    MenuBar()
    MenuItem(303, "Add Bank Object"+Chr(9)+"(A)")    
    MenuItem(319, "Add Cube"+Chr(9)+"(C)")    
    MenuItem(320, "Add Plane"+Chr(9)+"(P)")    
    MenuItem(318, "Add Sphere"+Chr(9)+"(Shift+S)") 
    MenuItem(321, "Add Cylinder"+Chr(9)) 
    MenuBar()
    MenuItem(313, "Add Water"+Chr(9)+"(W)") 
    MenuItem(314, "Add Terrain"+Chr(9)+"(T)") 
    MenuBar()
    MenuItem(315, "Add Sphere-SkyDom"+Chr(9)+"(M)")
    MenuBar()
    MenuItem(304, "Add Point Light"+Chr(9)+"(L)")
    MenuItem(301, "Add Directionnal Light"+Chr(9)+"")
    MenuItem(302, "Add Spot Light"+Chr(9)+"")
    MenuBar()
    MenuItem(311, "Add Particle System"+Chr(9)+"(Ctrl+P)")
    DisableMenuItem(0,311,1)
        
    MenuTitle("Edit"); 351 -> 400
    MenuItem(330, "Move Selected Object"+Chr(9)+"(G + Arrows)"); 315
    MenuItem(331, "Rotate Selected Object"+Chr(9)+"(R + Arrows)");316
    MenuItem(332, "Scale Selected Object"+Chr(9)+"(S + Arrows)");317
    MenuBar()
    MenuItem(356, "Select All"+Chr(9)+"(Ctrl+A)")
    MenuItem(357, "Deselect All"+Chr(9)+"(Ctrl+D)")
    MenuBar()
    MenuItem(358, "Hide Selected Object"+Chr(9)+"(H)");302
    MenuItem(359, "UnHide All"+Chr(9)+"(Alt+H)");301
    MenuItem(355, "Delete Selected Object"+Chr(9)+"(Del)")
    MenuBar()
    MenuItem(351, "Freeze Selected"+Chr(9)+"(Ctrl+F)")
    MenuItem(352, "Freeze All"+Chr(9)+"(Shift+F)")
    MenuItem(353, "UnFreeze All"+Chr(9)+"(Alt+F)")
    MenuBar()
    MenuItem(354, "Duplicate Selected Object"+Chr(9)+"(Shift+D)")
    
    MenuTitle("View") ; 41- > 80
    MenuItem(41, "Grid")
    MenuItem(42, "Marker 3D")
    MenuItem(43, "View the Bounding Box")
    MenuBar()
    MenuItem(60, "Wireframe renderView"+Chr(9)+"(Alt+Z)")
    MenuBar()
    MenuItem(50, "Camera view"+Chr(9)+"(numpad0)")
    MenuItem(52, "Camera Game Reset"+Chr(9)+"Ctrl+R")    
    MenuItem(44, "Top view"+Chr(9)+"(numpad7)")
    MenuItem(45, "Bottom view"+Chr(9)+"(ctrl+numpad7)")
    MenuItem(46, "Front view"+Chr(9)+"(numpad1)")
    MenuItem(47, "Back view"+Chr(9)+"(ctrl+numpad1)")
    MenuItem(48, "Right view"+Chr(9)+"(numpad3)")
    MenuItem(49, "Left view"+Chr(9)+"(ctrl+numpad3)")
    MenuItem(51, "3D iso view"+Chr(9)+"(ctrl+numpad9)")
    MenuItem(54, "Perspective/orthogonal view"+Chr(9)+"(numpad5)")
    DisableMenuItem(0,54,1)
    MenuBar()
    MenuItem(53, "Camera BG color")
    
    
    
    MenuTitle("Game");441-> 460
    MenuItem(442,"Level Properties")
    MenuBar()
    MenuItem(441,"Test The Level")

    
    MenuTitle("World");401-> 440
    MenuItem(403,"Open The world Window")
    MenuBar()
    MenuItem(401,"Hide the Lights")
    
    
    MenuTitle("Help");81-> 120    
;     MenuItem(84, "Help")
;     MenuItem(85, "Help (Texte)")
;     MenuItem(86, "Help (Web)")
;     MenuBar() 
    MenuItem(83, "Preferences")
    MenuBar()    
    MenuItem(82, "Informations")
    MenuBar()
    MenuItem(81, "About")
    ;}
    ;{ toolbar
    CompilerIf #PB_Compiler_OS = #PB_OS_Linux Or #PB_Compiler_OS = #PB_OS_Windows
      If CreateToolBarPlus(#TOOLBAR, WindowID(#WindowMain))
        ToolBarStandardButton(0, #PB_ToolBarIcon_New)
        ToolBarToolTip(#TOOLBAR, 0, "New Level")
        ToolBarStandardButton(2, #PB_ToolBarIcon_Open)
        ToolBarStandardButton(3, #PB_ToolBarIcon_Save)
        ToolBarStandardButton(325, #PB_ToolBarIcon_Delete)
        ;ToolBarImageButton(#toolbar_btn_move, ImageID(#ToolbarImg0),#PB_ToolBar_Toggle)
        ToolBarToolTip(#TOOLBAR, 325, "Delete the selected Object")
        ToolBarSeparator()        
        ToolBarStandardButton(11, #PB_ToolBarIcon_Undo)
        ToolBarStandardButton(12, #PB_ToolBarIcon_Redo)
        ; the transformation
        ToolBarSeparator()  
        ;ToolbarCheckBox(#Gadget_ShowCible,3,0,40,20,"Cible")  
        ToolBarImageButton(#toolbar_btn_move, ImageID(#ToolbarImg0),#PB_ToolBar_Toggle)
        ToolBarImageButton(#toolbar_btn_rot, ImageID(#ToolbarImg1),#PB_ToolBar_Toggle)
        ToolBarImageButton(#toolbar_btn_scale, ImageID(#ToolbarImg2),#PB_ToolBar_Toggle)
        ;ToolbarCombobox(#TOOLBAR_axe,3,0,60,#PB_Ignore)
        ToolbarCombobox(#Gadget_Axe,3,0,60,#PB_Ignore)
        AddGadgetItem(#Gadget_Axe,-1,"Axe X")
        AddGadgetItem(#Gadget_Axe,-1,"Axe Y")
        AddGadgetItem(#Gadget_Axe,-1,"Axe Z")
        AddGadgetItem(#Gadget_Axe,-1,"Axe XY")
        AddGadgetItem(#Gadget_Axe,-1,"Axe XZ")
        AddGadgetItem(#Gadget_Axe,-1,"Axe YZ")
        ; the snap
        ToolBarSeparator()        
        ToolBarImageButton(#Gadget_Snap, ImageID(#ToolbarImg3),#PB_ToolBar_Toggle)
        ;ToolbarButtonImage(#Gadget_Snap, 0,0,20,20,ImageID(#ToolbarImg3),#PB_Button_Toggle)
        ToolBarToolTip(#TOOLBAR,#Gadget_Snap,"Snap the object on a Grid")
        ToolbarSpin(#Gadget_SnapX,3,0,35,20,1,100,#PB_Spin_Numeric)
        ToolbarSpin(#Gadget_SnapY,3,0,35,20,1,100,#PB_Spin_Numeric)
        ToolbarSpin(#Gadget_SnapZ,3,0,35,20,1,100,#PB_Spin_Numeric)
        ; light
        ToolBarSeparator()
        ToolBarImageButton(#toolbar_btn_light, ImageID(#LightDyn),#PB_ToolBar_Toggle)
        ToolBarToolTip(#TOOLBAR, #toolbar_btn_light, "Activate The Light on the Scene")
        ToolBarSeparator()        
        ;ToolbarCombobox(#COMBO, 0, 0, 40, #PB_Ignore)
        ToolbarText(#ToolbarTxt_ViewZoom,0,3,65,20,"Zoom Speed")
        ToolbarSpin(#Gadget_ViewZoom,0,0,35,20,1,100,#PB_Spin_Numeric)
        ToolbarText(#ToolbarTxt_CameraSpeed,8,3,70,20,"Camera Speed")
        ToolbarSpin(#camera_FactorMove,5,0,35,20,1,10000,#PB_Spin_Numeric)
        ToolBarSeparator()
      Else
        MessageRequester("Error", "Impossible de crer une toolbar")
      EndIf
    CompilerEndIf
    SetWindowCallback(@ToolBarPlusCallback(), #WindowMain)
  ;}
    ;{ add status bar
    CreateStatusBar(#statusbar,WindowID(#WindowMain))
    AddStatusBarField(50)
    AddStatusBarField(200)
    AddStatusBarField(500)
    AddStatusBarField(400)
    ;}
    ;{ add panel
    UseGadgetList(WindowID(#WindowMain))
      ;{ Panel Scene tree
      If PanelGadget(#PanelTreeGadget, 5, 10+ToolBarHeight(#TOOLBAR), #PanelSceneWidth,#PanoObjetH-10); option\winH-60-StatusBarHeight(#statusbar)-ToolBarHeight(#TOOLBAR))
        AddGadgetItem(#PanelTreeGadget,0,"Scene")    
        TreeGadget(#Treegadget_Scene, 5, 5, #PanelSceneWidth-20, #PanoObjetH-100);option\winH-60-StatusBarHeight(#statusbar)-400-ToolBarHeight(#TOOLBAR)); , #PB_Tree_CheckBoxes)
        If OpenPreferences("preferences.ini")
          n = ReadPreferenceInteger("nb",12)
          ReDim SceneTree(n)
          Restore SceneTree
          For i = 0 To n    
            Read.s nom$
            SceneTree(i)\name$ = ReadPreferenceString("element"+Str(i),nom$)
          Next i      
          ClosePreferences()
        Else
          Restore SceneTree
          For i = 0 To 12     
            Read.s SceneTree(i)\name$
          Next i      
        EndIf  
        CloseGadgetList()         
        EnableGadgetDrop( #Treegadget_Scene, #PB_Drop_Private, #PB_Drag_Move, #Drop_Private )
        ;{ select (temporaire)
        OpenGadgetList(#PanelTreeGadget)
        AddGadgetItem(#PanelTreeGadget,1,"Select")
        ListViewGadget(#gadget_selectlist,5,5,#PanoOption-15,#PanoSelect - 70)
        CloseGadgetList()
       
         UpdateTreeGadget()  
      EndIf ;}
      
        ;{ bank
      If PanelGadget(#panelBank,5,30+#PanoObjetH+5,#PanoObjet+5,WindowHeight(0)-80-#PanoObjetH)
        AddGadgetItem(#panelBank,0,"Bank")
        ComboBoxGadget(#gadget_bank_Group,5,5,120,20)
        ComboBoxGadget(#gadget_bank_Theme,5,30,120,20)
        ListViewGadget(#gadget_bank_List,5,60,#PanoObjet-15,150)
        ButtonGadget(#gadget_bank_LoadMesh,5,220,120,20,"Load a Mesh")
        CheckBoxGadget(#Gadget_autoshadow,5,240,120,20,"Automatic Shadow")
        SetGadgetState(#Gadget_autoshadow,option\autoShadow)
        CloseGadgetList()
        ;}
        ;{ load mesh
        OpenGadgetList(#panelBank)
        AddGadgetItem(#panelBank,1,"Entity")
        ;CheckBoxGadget(#gadget_Mesh_lookat,5,5,140,20,"Camera look at new mesh")
        CheckBoxGadget(#gadget_Mesh_Select,5,25,140,20,"Select the new mesh")
        CheckBoxGadget(#gadget_Mesh_ScaleOk,5,45,140,20,"Scale of the new mesh")      
        SpinGadget(#gadget_Mesh_scale,5,70,60,20,1,100,#PB_Spin_Numeric)
        SetGadgetState(#gadget_Mesh_scale,20)
        ButtonGadget(#gadget_bank_LoadMesh,5,120,120,20,"Load a Mesh")
        ButtonGadget(#gadget_bank_LoadDir,5,150,120,20,"Load Directory")
        
        CheckBoxGadget(#Gadget_ShowCible,5,170,80,20,"Show Cible")    
        CheckBoxGadget(#Gadget_DirAuto,5,190,120,20,"Auto Directory")
        
        CloseGadgetList()
        ;}
        ;{ Action
        OpenGadgetList(#panelBank)
        AddGadgetItem(#panelBank,2,"Actions")
        ComboBoxGadget(#Gadget_ActionType,5,5,100,20)
        AddGadgetItem(#Gadget_ActionType,0,"NPC")
        AddGadgetItem(#Gadget_ActionType,1,"Teleporter")
        AddGadgetItem(#Gadget_ActionType,2,"Treasure")
        AddGadgetItem(#Gadget_ActionType,3,"Block")
        AddGadgetItem(#Gadget_ActionType,4,"Moved Obj")
        AddGadgetItem(#Gadget_ActionType,5,"CheckPoint")
        AddGadgetItem(#Gadget_ActionType,6,"Fontain")
        AddGadgetItem(#Gadget_ActionType,7,"Monster Event")
        StringGadget(#Gadget_ActionId,120,5,45,20,"")
        ; pnj
        
        ; teleporter
        StringGadget(#Gadget_ActionMapArrivee,5,35,160,20,"")
        StringGadget(#Gadget_ActionMapArriveePosX,5,60,50,20,"")
        StringGadget(#Gadget_ActionMapArriveePosY,60,60,50,20,"")
        StringGadget(#Gadget_ActionMapArriveePosZ,115,60,50,20,"")
        GadgetAction()
        CloseGadgetList()
        ;}
      EndIf
      ;}  
;       If PanelGadget(#PanelProperty,winW-#PanelPropertyWidth-5,10,#PanelPropertyWidth,winH-60-StatusBarHeight(#StatusBar))
;         AddPanelItem()
;       EndIf
      ;{ Infos, 
      ;If PanelGadget(#PanelLeft,5,30,#PanoObjet+5,#PanoObjetH);WindowHeight(0)-80-PanoPreviewH)
      h = option\winH-(60+StatusBarHeight(#StatusBar)+ToolBarHeight(#TOOLBAR)+#PanoObjetH+10)
      If PanelGadget(#PanelProperty,option\winW-#PanelPropertyWidth-5,10+ToolBarHeight(#TOOLBAR),#PanelPropertyWidth,h)
        AddPanelProperty()
        CloseGadgetList()       
      EndIf ;}
      ;{ panel Properties : object/camera/light/Fx
      If PanelGadget(#PanelSelect,WindowWidth(0)-#PanelPropertyWidth-5,WindowHeight(0)-#PanoObjetH-80+32,#PanelPropertyWidth+5,#PanoObjetH)
        ;{ object
        OpenGadgetList(#PanelSelect)
        AddGadgetItem(#PanelSelect,-1,"Objects")
        PropertyBoxObject()
        CloseGadgetList()
        ;}
        ;{ camera
        OpenGadgetList(#PanelSelect)
        AddGadgetItem(#PanelSelect,-1,"Camera")
        PropertyBoxCamera() ; sur ase3d_newUi.pb
        CloseGadgetList();}
        ;{ Light      
        OpenGadgetList(#PanelSelect)
        AddGadgetItem(#PanelSelect,-1,"Lights")
        ListViewGadget(#Gadget_LightList,5,5,140,150)
        
        ButtonGadget(#Gadget_LightColorBtn,5,170,70,20,"Color")
        ButtonGadget(#Gadget_LightColorSpecBtn,80,170,70,20,"SpecColor")
        ButtonGadget(#Gadget_LightLocate,5,190,70,20,"Locate Light")
        CheckBoxGadget(#Gadget_Lightshadow,5,210,60,20,"Shadow")
        ComboBoxGadget(#Gadget_LightType,5,230,100,20)
        AddGadgetItem(#Gadget_LightType,0,"Point")
        AddGadgetItem(#Gadget_LightType,1,"Directionnal")
        AddGadgetItem(#Gadget_LightType,2,"Spot")
        
        ComboBoxGadget(#Gadget_WorldShadow,5,260,100,20)      
        AddGadgetItem(#Gadget_WorldShadow,0,"No Shadow")
        AddGadgetItem(#Gadget_WorldShadow,1,"Shadow Modulative")
        AddGadgetItem(#Gadget_WorldShadow,2,"Shadow Additive")
        SetGadgetState(#Gadget_WorldShadow,2)
        CloseGadgetList() ;}
        CloseGadgetList() 
      EndIf
        ;}
      ;{ panel right : options plus utilis
      If option\OldUi 
        If PanelGadget(#PanelRight,WindowWidth(0)-#PanoOption-5,30,#PanoOption+5,WindowHeight(0)-80-#PanoSelect-#PanoLayer)
          ;AddGadgetItem(#PanelRight,0,"Options")
          ; ScrollAreaGadget(#sa_panOption,2,5,#PanoOption-7,WindowHeight(0)-80-#PanoSelect-#PanoLayer-45,#PanoOption-20,#PanoObjetH-60,5,#PB_ScrollArea_BorderLess)
          ;{ options
          If os = 1 ; mac os
            CheckBoxGadget(#Gadget_ShowCible,5,50,80,20,"Show Cible")
            
            dee=80
            ;CheckBoxGadget(#Gadget_Snap,5,dee,80,20,"Snapping")
            ;SetGadgetState(#Gadget_Snap,camera\SnapOk)
            ;SpinGadget(#Gadget_SnapX,5,dee+20,40,20,0,1000,#PB_Spin_Numeric)
            ; SpinGadget(#Gadget_SnapY,50,dee+20,40,20,0,1000,#PB_Spin_Numeric)
            ;SpinGadget(#Gadget_SnapZ,95,dee+20,40,20,0,1000,#PB_Spin_Numeric)
            ; CheckBoxGadget(#Gadget_SnapKeyboard,5,dee+40,120,20,"Keyboard snap")
            
            CheckBoxGadget(#Gadget_MouseAxe,5,dee+70,140,20,"Mouse Transformation")
            SetGadgetState(#Gadget_MouseAxe,option\axeMouse)
            dee +20
            ;       ComboBoxGadget(#Gadget_Axe,5,dee+70,100,20)
            ;       AddGadgetItem(#Gadget_Axe,0,"Axe X")
            ;       AddGadgetItem(#Gadget_Axe,1,"Axe Y")
            ;       AddGadgetItem(#Gadget_Axe,2,"Axe Z")
            ;       AddGadgetItem(#Gadget_Axe,3,"Axe XZ")
            ;       AddGadgetItem(#Gadget_Axe,4,"Axe XY")
            ;       AddGadgetItem(#Gadget_Axe,5,"Axe YZ")
            ;       SetGadgetState(#Gadget_Axe,camera\Axe)  
            
            CheckBoxGadget(#Gadget_ShowCadreSelect,5, dee+100,120,20,"Selection Rectangle")
            
            dee+20
            CheckBoxGadget(#Gadget_ModeSelection,5, dee+100,120,20,"Selection Additive")
            SetGadgetState(#Gadget_ModeSelection,option\ModeSelection)
            
            CheckBoxGadget(#Gadget_autoshadow,5,dee+120,120,20,"Automatic Shadow")
            SetGadgetState(#Gadget_autoshadow,option\autoShadow)
            CheckBoxGadget(#Gadget_DirAuto,5,dee+150,120,20,"Auto Directory")
          EndIf
          ;}
          ; CloseGadgetList() 
          ; CloseGadgetList() 
          CloseGadgetList() 
        EndIf
        ;     If PanelGadget(#PanelAffichage,WindowWidth(0)-#PanoOption-5,WindowHeight(0) - #PanoLayer - #PanoSelect -80+32,#PanoOption+5,#PanoLayer)
        ;       AddGadgetItem(#PanelAffichage,0,"View")
        ;       AddGadgetItem(#PanelAffichage,1,"Layers")
        ;       CloseGadgetList()
        ;     EndIf
                
;         If PanelGadget(#PanelSelect,WindowWidth(0)-#PanoOption-5,WindowHeight(0)-#PanoSelect-80+32,#PanoOption+5,#PanoSelect)
;           AddGadgetItem(#PanelSelect,1,"Select")
;           ListViewGadget(#gadget_selectlist,5,5,#PanoOption-15,#PanoSelect - 70)
;           CloseGadgetList()       
;         EndIf
        ;SplitterGadget(#Splitter_right1, WindowWidth(0)-#PanoOption-5,30,#PanoOption+5,WindowHeight(0)-80-#PanoSelect, #PanelRight, #PanelSelect)
      EndIf
      ;}
     
    ;}
    ;{ gadget tooltip
    If option\tooltip
      ; objets
      GadgetToolTip(#ObjectBlocked,"The entity can't be moved, rotated or scaled")
      GadgetToolTip(#ObjectMaterial,"Material Presets")
      ; bank
      GadgetToolTip(#gadget_bank_Group,"Group of the Mesh Bank")
      GadgetToolTip(#gadget_bank_Theme,"Sub Group of the Mesh Bank")
      GadgetToolTip(#gadget_Mesh_ScaleOk,"Scale the mesh before create the entity")
      GadgetToolTip(#gadget_Mesh_scale,"The Scale for the new entity")
      GadgetToolTip(#gadget_bank_LoadMesh,"Load a Mesh and Create a new Entity with it")
      GadgetToolTip(#gadget_bank_LoadDir,"Load a complete Directory with all the meshs in it.")
      GadgetToolTip(#Gadget_ActionId,"The Action Id of the Entity")
      ; camera
      GadgetToolTip(#CameraFov,"Camera Focal")
      GadgetToolTip(#Gadget_ViewZoom,"View Zoom")
      GadgetToolTip(#camera_FactorMove,"Moving Camera Factor")
      ;light 
      GadgetToolTip(#Gadget_WorldShadow,"World Shadow Type")
      GadgetToolTip(#Gadget_LightType,"Light Type")
      ; action teleport
      GadgetToolTip(#Gadget_ActionMapArrivee,"Number (id) or name of The Arrival Map")
      GadgetToolTip(#Gadget_ActionMapArriveePosX,"The Teleport Arrival Position in X")
      GadgetToolTip(#Gadget_ActionMapArriveePosY,"The Teleport Arrival Position in Y")
      GadgetToolTip(#Gadget_ActionMapArriveePosZ,"The Teleport Arrival Position in Z")
      
      ; options
      GadgetToolTip(#Gadget_SnapX,"Define the size in X of the Snapping") 
      GadgetToolTip(#Gadget_SnapY,"Define the size in Y of the Snapping") 
      GadgetToolTip(#Gadget_SnapZ,"Define the size in Z of the Snapping") 
      GadgetToolTip(#Gadget_Axe,"Define the Axe for the transformation") 
    EndIf
    ;}
    ;{ shortcut
    ; file
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Control|#PB_Shortcut_N,1)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Control|#PB_Shortcut_O,2)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Control|#PB_Shortcut_Alt|#PB_Shortcut_S,5)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Control|#PB_Shortcut_S,4)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Control|#PB_Shortcut_I,3)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Control|#PB_Shortcut_Shift|#PB_Shortcut_S,10)
    ; view
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Control|#PB_Shortcut_Pad7,45)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Control|#PB_Shortcut_Pad3,49)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Control|#PB_Shortcut_Pad1,47)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Alt|#PB_Shortcut_Z,60)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Control|#PB_Shortcut_R,52)
    ; object
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Shift|#PB_Shortcut_S,318)
    ; edit objet
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Control|#PB_Shortcut_F,351)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Shift|#PB_Shortcut_F,352)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Alt|#PB_Shortcut_F,353)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Shift|#PB_Shortcut_D,354)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Delete,355)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Control|#PB_Shortcut_A,356)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Control|#PB_Shortcut_D,357)
    AddKeyboardShortcut(#WindowMain,#PB_Shortcut_Alt|#PB_Shortcut_H,359)    
    ; ; sans ctrl, alt ou shift
    AddKeyboardShortcutMenu()
    ;}
    ;{ menu popup 1
    If CreatePopupImageMenu(#Menupopup1)
      MenuItem(99,"Add Object")
      MenuBar()
      For i = 0 To ArraySize(SceneTree())
        MenuItem(100+i,SceneTree(i)\name$,ImageID(i))
      Next i
    EndIf
    ;}
    ;{ open screen
    ScreenWidth  = option\WinW - #PanoObjet - #PanelPropertyWidth -10 -10
    ScreenHeight = option\WinH - MenuHeight() - StatusBarHeight(#statusbar)- #TopEspace - #bottomEspace
    Result = OpenWindowedScreen(WindowID(#WindowMain),#PanoObjet+10, #TopEspace, ScreenWidth, ScreenHeight, 0,0,0)
    ;SetFrameRate(90)
    ;}    
    ;{ initialisation
    InitObj()
    SetMenuItemState(0,401,option\LightActive)
    SetToolBarButtonState(#TOOLBAR,#toolbar_btn_light,option\LightActive)
    SetToolBarButtonState(#TOOLBAR,#Gadget_Snap,camera\SnapOk)
    SetGadgetState(#Gadget_SnapX,camera\snap\X)
    SetGadgetState(#Gadget_SnapY,camera\snap\Y)
    SetGadgetState(#Gadget_SnapZ,camera\snap\Z)
    SetGadgetState(#Gadget_ActionType,0)
    SetToolBarButtonState(#TOOLBAR,#Gadget_ViewZoom,option\ViewZoom)
    SetGadgetState(#Gadget_ViewZoom,10)
    SetGadgetState(#camera_FactorMove,camera\FactorMove*10000)
    ;}
  EndIf  
  ProcedureReturn Result
EndProcedure
Procedure WindowClose(window=#windowfille)
  If GetActiveWindow() = window
    CloseWindow(window)
    SetActiveWindow(#WindowMain)
  EndIf
EndProcedure

;others windows
Procedure OpenWorld()
  If OpenWindow(#windowWorld,0,0,400,300,"World",#PB_Window_SystemMenu|#PB_Window_ScreenCentered,WindowID(#WindowMain))
    If PanelGadget(#winWorldpanel,10,10,380,260)
      AddGadgetItem(#winWorldpanel,0,"World") ; 1041-1060
      ButtonGadget(#winWorldBtnAmbient,5,5,80,20,"Ambient Color")
      AddGadgetItem(#winWorldpanel,1,"Fog") ;1003 - 1019
      CheckBoxGadget(#winWorldCbFog,5,5,120,20,"Add a Fog to the level")
      ButtonGadget(#winWorldCbFogCol,5,30,100,20,"Color of the Fog")
      SpinGadget(#winWorldCbFogInt,5,60,60,20,0,100,#PB_Spin_Numeric)
      SetGadgetState(#winWorldCbFogInt,world\Fog\Intensity*100)
      SpinGadget(#winWorldCbFogStart,5,90,60,20,0,100000,#PB_Spin_Numeric)
      SetGadgetState(#winWorldCbFogStart,world\Fog\StarDist)
      SpinGadget(#winWorldCbFogEnd,5,120,60,20,0,100000,#PB_Spin_Numeric)
      SetGadgetState(#winWorldCbFogEnd,world\Fog\EndDist)
      ButtonGadget(#winWorldCbFogAdd,120, 180, 140,20,"Add The Fog in the Scene")
      AddGadgetItem(#winWorldpanel,2,"SkyDom") ; 1020 - 1040
      ButtonGadget(#winWorldBtnSkydomTexture,10, 10, 140,20,"Choose the texture")
      ButtonGadget(#winWorldBtnSkydomAdd,120,180,100,20,"Add A Skydom")
      AddGadgetItem(#winWorldpanel,3,"SkyBox") ; 1041 - 1050
      ButtonGadget(#winWorldBtnSkyboxAdd,120,180,100,20,"Add A SkyBox")
      AddGadgetItem(#winWorldpanel,5,"Sun")
      CloseGadgetList()
    EndIf
  EndIf
EndProcedure
Procedure OpenPref()
  If OpenWindow(#WindowPref,0,0,400,300,"Preferences",#PB_Window_SystemMenu|#PB_Window_ScreenCentered,WindowID(#WindowMain))
    If PanelGadget(#winPrefPanel,5,5,390,250)
      ;{ general
      AddGadgetItem(#winPrefPanel,0,"General")
      ComboBoxGadget(#winPrefCboxLang,10,10,100,20)
      AddGadgetItem(#winPrefCboxLang,0,"Langue : Fr")
      AddGadgetItem(#winPrefCboxLang,1,"Lang : Eng")
      Select option\Lang$ 
        Case "fr"
          SetGadgetState(#winPrefCboxLang,0)
        Case "eng"
          SetGadgetState(#winPrefCboxLang,1)
      EndSelect
      CheckBoxGadget(#winPrefCbExit,10,40,100,20,"Confirm Exit")
      SetGadgetState(#winPrefCbExit,option\confirmExit)
      confirmExit = option\confirmExit
      CheckBoxGadget(#winPrefCbAutosize,10,65,150,20,"Desktop -Window Size")
      SetGadgetState(#winPrefCbAutosize,option\autosize)
      autosize = option\autosize
      CheckBoxGadget(#winPrefCbTooltip,10,90,150,20,"ToolTip for Gadget")
      SetGadgetState(#winPrefCbTooltip,option\tooltip)
      tooltip = option\tooltip    
      CloseGadgetList() ;}
      ;{ option
      OpenGadgetList(#winPrefPanel)
      AddGadgetItem(#winPrefPanel,-1,"Options")    
      CheckBoxGadget(#Gadget_MouseAxe,5,30,140,20,"Mouse Transformation")
      SetGadgetState(#Gadget_MouseAxe,option\axeMouse)
      
      CheckBoxGadget(#Gadget_ShowCadreSelect,5, 60,120,20,"Selection Rectangle")
      CheckBoxGadget(#Gadget_ModeSelection,5, 80,120,20,"Selection Additive")
      SetGadgetState(#Gadget_ModeSelection,option\ModeSelection)
      
      CloseGadgetList() ;}
      OpenGadgetList(#winPrefPanel)
      AddGadgetItem(#winPrefPanel,-1,"Primitive")
      SpinGadget(#winPrefSpTexture,5,5,50,20,1,1000,#PB_Spin_Numeric)
      GadgetToolTip(#winPrefSpTexture,"Texture RepeatFor Plane")
      SetGadgetState(#winPrefSpTexture,10)
      CloseGadgetList()   
    EndIf
    ButtonGadget(#winPrefBtnOk,120,270,80,20,"Ok")
    ButtonGadget(#winPrefBtnCancel,200,270,80,20,"Cancel")
    ; tooltip
    GadgetToolTip(#Gadget_MouseAxe,"Object Transformation are made by Mouse Screen, and not PickMouse")
    GadgetToolTip(#Gadget_ShowCadreSelect,"Object selected is drawn with a selection rectangle")
    GadgetToolTip(#Gadget_ModeSelection,"Draw the selection in additive mode")
    GadgetToolTip(#Gadget_autoshadow,"Add the shadow on object at their creation")
    GadgetToolTip(#Gadget_DirAuto,"When you open a mesh, scene or material, the directory is automatically opened")
    ;init gadget
    SetGadgetState(#Gadget_DirAuto,option\autodir)
    SetGadgetState(#Gadget_ShowCadreSelect,1)
  EndIf
EndProcedure
Procedure OpenAbout()
  If OpenWindow(#windowAbout,0,0,320,200,"About",#PB_Window_SystemMenu|#PB_Window_ScreenCentered,WindowID(#WindowMain))
    txt$ = "Arkeos Scene Editor3D (Ase3D). Version "+Version$+"."+Chr(13)
    txt$ + "Create the levels for your game with this Level Editor"+ Chr(13)
    txt$ + Chr(13)+"Made By blendman, in Purebasic."+Chr(13)
    txt$ + Chr(13)+"April & May 2012."
    TextGadget(#WinAboutTxt,20,40,280,110,txt$,#PB_Text_Border)
    ButtonGadget(#WinAboutBtnOk,120,170,80,20,"Ok")
  EndIf
EndProcedure
Procedure OpenInfo()
  If OpenWindow(#windowInfo,0,0,320,200,"Informations",#PB_Window_SystemMenu|#PB_Window_ScreenCentered,WindowID(#WindowMain))
    If PanelGadget(#winInfoPanel,5,5,310,150)
      AddGadgetItem(#winInfoPanel,0,"Object")
      txt$ = "Left click to Select and edit the scene/mesh, light.."+ Chr(13)+ Chr(13)
      txt$ + "Ctrl/Alt + mouse move to move the 3D view"+ Chr(13)+ Chr(13)
      txt$ + "G : move the object."+ Chr(13)
      txt$ + "R : Rotate the object"+ Chr(13)
      txt$ + "S : scale the object."+Chr(13)+ Chr(13)
      
      EditorGadget(#winInfoEd,5,5,280,110,#PB_Text_Border|#PB_Editor_ReadOnly)
      SetGadgetText(#winInfoEd,txt$)
      AddGadgetItem(#winInfoPanel,1,"Axe")
      txt$=""
      txt$ + "You can use X, Y or Z to constraint to an Axe"+ Chr(13)+ Chr(13)
      txt$ + "ctrl+Z constraint To XY axe" + Chr(13)
      txt$ + "Ctrl+Y constraint To ZX axe"+Chr(13)
      txt$ + "Ctrl+X constraint To YZ axe"+Chr(13)
      EditorGadget(#winInfoEd2,5,5,280,110,#PB_Text_Border|#PB_Editor_ReadOnly)
      SetGadgetText(#winInfoEd2,txt$)
      CloseGadgetList()
    EndIf
    ButtonGadget(#winInfoBtnOk,120,170,80,20,"Ok")
  EndIf
EndProcedure
Procedure OpenLevelProp()
  If OpenWindow(#windowLevelProp,0,0,400,300,"Level Properties",#PB_Window_SystemMenu|#PB_Window_ScreenCentered,WindowID(#WindowMain))
    ;SetActiveWindow(#windowLevelProp)     
    If PanelGadget(#winLevelpropPanel,5,5,390,260)
      AddGadgetItem(#winLevelpropPanel,0,"General")
      AddGadgetItem(#winLevelpropPanel,1,"Weather")
      CloseGadgetList()
    EndIf
    ButtonGadget(#winLevelpropBtnOk,120,270,80,20,"Ok")
    ButtonGadget(#winLevelpropBtnCancel,200,270,80,20,"Cancel")
  EndIf 
EndProcedure
;}

;{ UI (grid, marker3D, bbox, camera, infos, list selection)
Procedure CreateGrid()
  CreateMaterial(#UIGrid, LoadTexture(#UiTxGrid,"grid.png"))
  MaterialBlendingMode(#UIGrid,#PB_Material_AlphaBlend)
  DisableMaterialLighting(#UIGrid, 1)
  CreatePlane(#UiMeshGrid, 1000, 1000, 50, 50, 10, 10)    
  CreateEntity(#EntGrid,MeshID(#UiMeshGrid),MaterialID(#UIGrid))
  level\NbEntity +1
  level\NbMaterial +1
  level\NbMesh + 1
  level\NbEntity + 1
EndProcedure
Procedure AddGrid(mode=0)
  HideEntity(#EntGrid,option\Grid)
  SetMenuItemState(0,41,1-option\Grid)
EndProcedure
Procedure AddMarker3D(mode=0)
  If mode = 0 ; create line
    CreateLine3D(#line3D  , 0, 0, 0, RGB(255,   0,   0), 500,   0,   0, RGB(255,   0,   0))  ; Axis X
    CreateLine3D(#line3D+1, 0, 0, 0, RGB(  0, 255,   0),   0, 500,   0, RGB(  0, 255,   0))  ; Axis Y
    CreateLine3D(#line3D+2, 0, 0, 0, RGB(  0,   0, 255),   0,   0, 500, RGB(  0,   0, 255))  ; Axis Z
  Else
    For i = 0 To 2
      FreeMesh(#line3D+i)
    Next i
  EndIf
  SetMenuItemState(0,42,1-mode)
EndProcedure
Procedure AddBboxSlect(mode=0)
  If mode =0
        
  Else
    
  EndIf  
EndProcedure

;camera
Procedure SetCameraProp()
  SetGadgetState(#CameraRotZ,CameraRoll(#CameraGame))
  SetGadgetState(#CameraRotX,CameraPitch(#CameraGame))
  SetGadgetState(#CameraRotY,CameraYaw(#CameraGame))
  SetGadgetState(#CameraPosX,CameraX(#CameraGame))
  SetGadgetState(#CameraPosY,CameraY(#CameraGame))
  SetGadgetState(#CameraPosZ,CameraZ(#CameraGame))
EndProcedure
Procedure InitCamera()
  If OpenPreferences("preferences.ini")
    PreferenceGroup("general") 
    camera\name$ ="CameraMain"
    camera\pos\x =  ReadPreferenceInteger("cameraX",0) 
    camera\pos\Y =  ReadPreferenceInteger("cameraY",0) 
    camera\pos\z =  ReadPreferenceInteger("cameraZ",400) 
    camera\rot\X =  ReadPreferenceInteger("cameraRoll",0) 
    camera\rot\Z =  ReadPreferenceInteger("cameraYaw",0)
    camera\rot\Y =  ReadPreferenceInteger("cameraPitch",0)
    CameraLocate(#CameraGame, camera\pos\x, camera\pos\Y, camera\pos\z)
    RotateCamera(#CameraGame,camera\rot\X,camera\rot\Z,camera\rot\Y,#PB_Absolute)
    ClosePreferences()
  EndIf
EndProcedure
Procedure ResetCamera()
  CameraLocate(#CameraGame, 0, 0, 400)
  CameraFOV(#CameraGame,35)
  RotateCamera(#CameraGame,0,0,0,#PB_Absolute)
EndProcedure
Procedure BaseCamera(mode=0)
  With camera
    If mode = 0
      \pos\X = CameraX(#CameraGame)
      \pos\Y = CameraY(#CameraGame)
      \pos\Z = CameraZ(#CameraGame)
      \rot\X = CameraPitch(#CameraGame)
      \rot\Y = CameraYaw(#CameraGame)
      \rot\Z = CameraRoll(#CameraGame)
    Else 
      RotateCamera(#CameraGame,\rot\X,\rot\Y,\rot\Z)
      CameraLocate(#CameraGame,\pos\X,\pos\Y,\pos\Z)
    EndIf
  EndWith
EndProcedure

Procedure ChangeCamera(view=0)
  camera\view = 1
  ;CameraProjectionMode(#CameraGame,#PB_Camera_Orthographic) ; <----------------------------- BUG :  si on laisse ici, a bug et si on l'enlve, a ne bug plus.

  Select view
      
    Case 0; Top view camera (menuitem 44)
      
      RotateCamera(#CameraGame,-90,0,0)
      CameraLocate(#CameraGame,0,1000,0)
      
    Case 1; bottom ; 45
      RotateCamera(#CameraGame,90,0,0)
      CameraLocate(#CameraGame,0,-1000,0)
      
    Case 2; front view 46
      RotateCamera(#CameraGame,0,0,0)
      CameraLocate(#CameraGame,0,0,800)
      
    Case 3 ;back; 47
      RotateCamera(#CameraGame,0,180,0)
      CameraLocate(#CameraGame,0,0,-800)
      
    Case 4 ; right; 48
      RotateCamera(#CameraGame,0,90,0)
      CameraLocate(#CameraGame,800,0,0)
      
    Case 5 ; left  49
      RotateCamera(#CameraGame,0,-90,0)
      CameraLocate(#CameraGame,-800,0,0)
      
    Case 6 ; normal perspetive 50
      BaseCamera(1)
      camera\view =0
      
    Case 7 ; 3d iso
      RotateCamera(#CameraGame,-30,45,0)
      CameraLocate(#CameraGame,650,650,650)
      
    Case 8 ; reset the camera
      ResetCamera()
      
  EndSelect 
  
  For i = 0 To 51
    SetMenuItemState(0,i+44, 0)
  Next i

  SetMenuItemState(0,44+view,1)
EndProcedure

; UI
Procedure UpdateInfos()
  txt$ = "Nb Obj (level) : "+Str(Level\NbEntity-Level\NbLight-2)+Chr(13)  
  txt$ + "Nb Entity : "+Str(Level\NbEntity)+Chr(13)
  txt$ + "Nb Texture : "+Str(Level\NbTexture)+Chr(13)
  txt$ + "Nb Material : "+Str(Level\NbMaterial)+Chr(13)
  txt$ + "Nb Light : "+Str(Level\NbLight)+Chr(13)
  txt$ + "Nb Poly (view) : "+Str(CountRenderedTriangles())+Chr(13)
  If Level\NbPolyMax<CountRenderedTriangles()
    Level\NbPolyMax = CountRenderedTriangles()
  EndIf  
  txt$ + "Nb Poly (Max) : "+Str(Level\NbPolyMax)+Chr(13)  
  txt$ + "Level Name : "+Level\Name$+Chr(13)  
  SetGadgetText(#gadget_Txt_info,txt$)
EndProcedure
Procedure UpdateListSelect()
  ClearGadgetItems(#gadget_selectlist)
  ForEach object()
    If object()\Type <> 100
      AddGadgetItem(#gadget_selectlist,-1,object()\Name$)
    EndIf            
  Next
EndProcedure

;utilities
Procedure Screen3DStats()
  If Screen3DRequester_ShowStats
    Debug level\NbEntity
    Debug Level\NbEntity
    Debug ListSize(object()) 
    Debug CountRenderedTriangles()
  EndIf
EndProcedure
;}

;{ open, save, bank....
;directory
Procedure.s Dir(d$)
  If option\autodir
    dir$=GetCurrentDirectory()+d$
    Debug dir$
    ProcedureReturn dir$
  Else
    dir$=""
  EndIf  
  ProcedureReturn dir$
EndProcedure

; preferences
Procedure OpenAppli()
  If OpenPreferences("preferences.ini")
    PreferenceGroup("general")  
    option\lang$ = ReadPreferenceString("lang","fr") 
    option\ViewZoom = ReadPreferenceInteger("viewzoom",1)     
    If option\lang$=""
      option\lang$="fr"
    EndIf    
    color = ReadPreferenceInteger("Color_FG",0)  
    color_BG = ReadPreferenceInteger("Color_BG",RGB(255,255,255))  
    color_R = Red(color)
    color_G = Green(color)
    color_B = Blue(color) 
    flagId = ReadPreferenceInteger("camera",1)
    ;Move_Camera()
    option\confirmExit = ReadPreferenceInteger("confirmExit",1)
    option\tooltip =  ReadPreferenceInteger("tooltip",1)
    option\axeMouse = ReadPreferenceInteger("axeMouse",1)    
    option\ModeSelection= ReadPreferenceInteger("SelectionAdditive",1)
    option\autoShadow= ReadPreferenceInteger("autoshadow",1)
    option\autodir= ReadPreferenceInteger("autodir",1)
    
    camera\SnapOk = ReadPreferenceInteger("snap",0)
    camera\Snap\X = ReadPreferenceInteger("snapX",25)
    camera\Snap\Y = ReadPreferenceInteger("snapY",25)
    camera\Snap\Z = ReadPreferenceInteger("snapZ",25)
    fact${6} = ReadPreferenceString("FactorMove","0.01")
    camera\FactorMove = ValD(fact$)
    
    ; size
    option\autosize = ReadPreferenceInteger("autosize",1) 
    If option\autosize = 0
      option\winW = ReadPreferenceInteger("winW",1024) 
      option\winH = ReadPreferenceInteger("winH",768) 
    Else
      ExamineDesktops()
      option\winW = DesktopWidth(0)
      option\winH = DesktopHeight(0)-32
    EndIf
    ClosePreferences()   
  Else
    MessageRequester("Erreur","Impossible de charger le fichier Prfrence"+Chr(13)+"Les prfrences par dfaut seront charges.",#MB_ICONERROR)
  EndIf
EndProcedure
Procedure CloseAppli() 
  If OpenPreferences("preferences.ini")
    PreferenceGroup("general")
    WritePreferenceString("lang",option\lang$)
    WritePreferenceString("version",Version$)   
    WritePreferenceInteger("camera",flagId) 
    WritePreferenceInteger("cameraX",CameraX(#CameraGame)) 
    WritePreferenceInteger("cameraY",CameraY(#CameraGame)) 
    WritePreferenceInteger("cameraZ",CameraZ(#CameraGame))
    
    WritePreferenceInteger("cameraRoll",CameraRoll(#CameraGame)) 
    WritePreferenceInteger("cameraYaw",CameraYaw(#CameraGame)) 
    WritePreferenceInteger("cameraPitch",CameraPitch(#CameraGame)) 
    
    WritePreferenceInteger("viewzoom",option\ViewZoom)
    WritePreferenceInteger("confirmExit",option\confirmExit)
    WritePreferenceInteger("tooltip",option\tooltip)
    WritePreferenceInteger("axeMouse",option\axeMouse)
    WritePreferenceInteger("SelectionAdditive",option\ModeSelection)
    WritePreferenceInteger("autoshadow",option\autoShadow)
    WritePreferenceInteger("autodir",option\autodir)    
    WritePreferenceInteger("autosize",option\autosize)    
    WritePreferenceInteger("snap",camera\SnapOk)
    WritePreferenceInteger("snapX",camera\Snap\X)
    WritePreferenceInteger("snapY",camera\Snap\Y)
    WritePreferenceInteger("snapZ",camera\Snap\Z)
    fact${6} = StrD(camera\FactorMove)
    WritePreferenceString("FactorMove",fact$)
     
    ClosePreferences()
  Else
    MessageRequester("Erreur","Impossible d'enregistrer le fichier Prfrence.",#MB_ICONERROR)
  EndIf
EndProcedure

; level
Procedure InitLevel()
  With Level
    \NbEntity = 50 ; 50 entity de base (line 3D, boudingbox, sphere pour light...
    \NbMaterial = 10 ; grid, cible, bbox rect
    \NbMesh = 10 ; grid, light, cible...
    \NbObjet = 1; une camera de base dans le level
    \NbLight = 0; pas de light
  EndWith
EndProcedure

; librairie (mesh, material, texture
Procedure SaveBibli(file$)
  Debug "nbre de mesh(bibli)  :"+Str(ListSize(bibli()))
  If CreateFile(#savefile,RemoveString(file$,".ark")+".bib")
    ForEach bibli()    
      With bibli()
        param$ = "mesh;"+RemoveString(\MeshName$,".mesh")+";"
        WriteStringN(#savefile,param$)        
      EndWith    
    Next
    ForEach bibli_mat()
      With bibli_mat()
        param$ = "mat;"+RemoveString(\MaterialName$,"data\Material\")+";"
        WriteStringN(#savefile,param$) 
      EndWith      
    Next
    CloseFile(#savefile)
  Else
    MessageRequester("Error","Unable to create the save File 'Lib' : "+file$,0)
  EndIf  
EndProcedure
Procedure OpenBibli(file$)
  
  
EndProcedure

; scene
Procedure ExportForGame()
  ReleaseMouse(1)
  Debug "nbre d'objet  sauver : "+Str(ListSize(object()))
  file$=SaveFileRequester("Save a File","","*.ale|*.ale",0)
  SaveBibli(RemoveString(file$,".ale"))
  If file$ <>""
    If CreateFile(#savefile,RemoveString(file$,".ale")+".ale")
      WriteStringN(#savefile,"{Created with the Arkeos Scene Editor 3D (Ase3D) - 2012}")     
      ; Level
      param$ = "Level/"+Level\Name$+"/"
      WriteStringN(#savefile,param$)
      ; world
      With world
        param$ = "World/"+Str(\AmbientColor)+"/"+Str(\ShadowDistance)+"/"+Str(\ShadowType)+"/"
        param$ + Str(\Fog\actif)+"/"+Str(\Fog\Color)+"/"+Str(\Fog\Intensity)+"/"+Str(\Fog\StarDist)+"/"+Str(\Fog\EndDist)+"/"
        param$ + Str(\Skydom\SkyOk)+"/"+\Skydom\SkyImg$+"/"+Str(\Skydom\SkyCurve)+"/"
        param$ + Str(\Skybox\SkyOk)+"/"+\Skybox\SkyImg$+"/"  
        param$ + Str(\Sun\x)+"/"+Str(\Sun\y)+"/"+Str(\Sun\z)+"/"+Str(\Sun\color)+"/"
        WriteStringN(#savefile,param$)
      EndWith    
      ; les objets
      ForEach object() 
        With object()
          Select  \type 
            Case 0,1,2,3 ; objets
              mat$ = RemoveString(\MaterialName$,".material")
              mat$ = RemoveString(\MaterialName$,"data\Material\")
              param$ = "Obj/"+RemoveString(\MeshName$,".mesh")+"/"+mat$+"/"+Str(\pos\x)+"/"+Str(\pos\y)+"/"+Str(\pos\z)+"/"
              siz${5} = StrD(\Size)
              param$ + Str(\Rot\x)+"/"+Str(\Rot\y)+"/"+Str(\Rot\z)+"/"+siz$+"/"              
              param$ + Str(\scale\X)+"/"+Str(\scale\Y)+"/"+Str(\scale\Z)+"/"+Str(\CastShadow)+"/"
              WriteStringN(#savefile,param$)
              
            Case 50 ; water (made with createwater())
              param$ = "Water/"+Str(\entityId)+"/"+Str(\pos\x)+"/"+Str(\pos\y)+"/"+Str(\pos\z)+"/"
              WriteStringN(#savefile,param$)
              
            Case 100 ; light
              param$ = "Light/"+Str(\LightType)+"/"+Str(\pos\x)+"/"+Str(\pos\y)+"/"+Str(\pos\z)+"/"
              param$ + Str(\Color)+"/"+Str(\ColorSpec)+"/"+Str(\Shadow)+"/"
              WriteStringN(#savefile,param$)              
              
          EndSelect
        EndWith        
      Next       
      CloseFile(#savefile)
    Else
      MessageRequester("Error","Unable to create the save File : "+file$,0)
    EndIf    
  EndIf  
  ReleaseMouse(0)

EndProcedure
Procedure SaveScene(mode = 0)
  ReleaseMouse(1)
  Debug "nbre d'objet  sauver : "+Str(ListSize(object()))
  dir$= dir("scene\")
  file$=SaveFileRequester("Save a File",dir$,"*.ark|*.ark",0)
  SaveBibli(RemoveString(file$,".ark"))
  If file$ <>""
    If CreateFile(#savefile,RemoveString(file$,".ark")+".ark")
      WriteStringN(#savefile,"{Created with the Arkeos Scene Editor 3D (Ase3D) - 2012}")     
      ; infos general
      If mode =0
        WriteStringN(#savefile,"Objects/"+Str(level\NbEntity-2-level\NbLight)+"/") 
        WriteStringN(#savefile,"Materials/"+Str(level\NbMaterial)+"/")     
        WriteStringN(#savefile,"Textures/"+Str(level\NbTexture)+"/")     
        WriteStringN(#savefile,"Lights/"+Str(level\NbLight)+"/")      
        WriteStringN(#savefile,"PolyMax/"+Str(level\NbPolyMax)+"/")     
        ; Level
        param$ = "Level/"+Level\Name$+"/"
        WriteStringN(#savefile,param$)
        ; world
        With world
          param$ = "World/"+Str(\AmbientColor)+"/"+Str(\ShadowDistance)+"/"+Str(\ShadowType)+"/"
          param$ +Str(\Fog\actif)+"/"+Str(\Fog\Color)+"/"+Str(\Fog\Intensity)+"/"+Str(\Fog\StarDist)+"/"+Str(\Fog\EndDist)+"/"
          param$ +Str(\Skydom\SkyOk)+"/"+\Skydom\SkyImg$+"/"+Str(\Skydom\SkyCurve)+"/"
          param$ +Str(\Skybox\SkyOk)+"/"+\Skybox\SkyImg$+"/"            
          WriteStringN(#savefile,param$)
        EndWith  
      EndIf
      ; les objets
      ForEach object() 
        With object()
          If \Selected = 1 Or mode = 0
            Select  \type 
              Case 0,1,2,3 ; objets
                mat$ = RemoveString(\MaterialName$,".material")
                mat$ = RemoveString(\MaterialName$,"data\Material\")
                param$ = "Obj/"+RemoveString(\MeshName$,".mesh")+"/"+mat$+"/"+Str(\pos\x)+"/"+Str(\pos\y)+"/"+Str(\pos\z)+"/"
                siz${5} = StrD(\Size)
                param$ + Str(\Rot\x)+"/"+Str(\Rot\y)+"/"+Str(\Rot\z)+"/"+siz$+"/"              
                param$ + Str(\scale\X)+"/"+Str(\scale\Y)+"/"+Str(\scale\Z)+"/"+Str(\CastShadow)+"/"
                WriteStringN(#savefile,param$)
                
              Case 50 ; water (made with createwater())
                param$ = "Water/"+Str(\entityId)+"/"+Str(\pos\x)+"/"+Str(\pos\y)+"/"+Str(\pos\z)+"/"
                WriteStringN(#savefile,param$)
                
              Case 100 ; light
                param$ = "Light/"+Str(\LightType)+"/"+Str(\pos\x)+"/"+Str(\pos\y)+"/"+Str(\pos\z)+"/"
                param$ + Str(\Color)+"/"+Str(\ColorSpec)+"/"+Str(\Shadow)+"/"
                WriteStringN(#savefile,param$)              
                
            EndSelect
          EndIf
        EndWith        
      Next       
      CloseFile(#savefile)
    Else
      MessageRequester("Error","Unable to create the save File : "+file$,0)
    EndIf    
  EndIf  
  ReleaseMouse(0)
EndProcedure

Procedure OpenScene()
  ReleaseMouse(1)
  dir$ = dir("scene\")
  file$=OpenFileRequester("Open A File",dir$,"*.ark|*.ark",0)
  If file$ <>""
    If OpenFile(#savefile,RemoveString(file$,".ark")+".ark")
      While Eof(#savefile)=0
        a$ = ReadString(#savefile)   
        max +1
      Wend  
      StatusBarProgress(0,2,1,#PB_StatusBar_Raised,0,max*2)
    EndIf
    If OpenFile(#savefile,RemoveString(file$,".ark")+".ark")
      While Eof(#savefile)=0
        a$ = ReadString(#savefile)        
        typ$ = StringField(a$,1, "/" ) 
        valeur + 1
        StatusBarProgress(0,2,valeur)
        compt= CountString (a$,"/")
        Select typ$
          Case "dir"            
            level\dir$ = StringField(a$,2,"/") 
            
          Case "Level"
            Level\Name$ = StringField(a$,2,"/") 
            ;{ world
          Case "World"
            With world
              \AmbientColor =Val(StringField(a$,2,"/"))
              \ShadowDistance =Val(StringField(a$,3,"/"))
              \ShadowType =Val(StringField(a$,4,"/")) 
              WorldShadows( \ShadowType,\ShadowDistance)
              ; fog
              \Fog\actif =Val(StringField(a$,5,"/"))              
              \Fog\Color =Val(StringField(a$,6,"/"))
              \Fog\Intensity =Val(StringField(a$,7,"/")) 
              \Fog\StarDist =Val(StringField(a$,8,"/")) 
              \Fog\EndDist =Val(StringField(a$,9,"/"))
              If \Fog\actif
                Fog(\Fog\Color,\Fog\Intensity,\Fog\StarDist,\Fog\EndDist)
              EndIf
              
              ; skydom
              \Skydom\SkyOk =Val(StringField(a$,10,"/")) 
              \Skydom\SkyImg$ =StringField(a$,11,"/") 
              \Skydom\SkyCurve =Val(StringField(a$,12,"/")) 
              If \Skydom\SkyOk
                ; CreateSkydom()
              EndIf
              ; skybox
              \Skybox\SkyOk =Val(StringField(a$,13,"/")) 
              \Skybox\SkyImg$ =StringField(a$,14,"/")
              If \Skybox\SkyOk
                CreateSkyBox()
              EndIf
            EndWith
            ;}            
            ;{ objet3D
          Case "Obj" ; c'est un objet3D
            AddElement(object_temp())            
            With object_temp()              
              For i=1 To compt 
                valeur$ = StringField(a$,i,"/") 
                Select i
                    ;{ general
                  Case 1 ; type d'objet - voir plus haut pour le dtail de chaque type
                    \Type = 0                    
                  Case 2 ; numero id de l'entity (pas ncessaire ?)
                    \MeshName$ = valeur$
                  Case 3
                    If valeur$="base"
                      \MaterialName$ = ""
                    Else                      
                      \MaterialName$ = valeur$
                    EndIf
                    
                    ;}
                    ;{ position
                  Case 4; position en X
                    \pos\x = Val(valeur$)
                  Case 5; position en Y
                    \pos\Y = Val(valeur$)
                  Case 6 ; position en Z
                    \pos\z = Val(valeur$)
                    ;}
                    ;{ Rotation
                  Case 7
                    \rot\x = Val(valeur$)
                  Case 8
                    \rot\y = Val(valeur$)
                  Case 9
                    \rot\z = 0;Val(valeur$)
                    ;}
                    ;{ size & scale
                  Case 10 ; size general
                    \size = ValD(valeur$)
                  Case 11; scale x
                    \scale\x = Val(valeur$)
                  Case 12; scale y
                    \scale\y = Val(valeur$)
                  Case 13; scale z
                    \scale\z = Val(valeur$)
                    ;}
                  Case 14
                    \CastShadow = Val(valeur$)                   
                EndSelect
              Next i 
            EndWith
            ;}
            ;{ light
          Case "Light"; c'est une light
            AddElement(object_temp())            
            With object_temp()              
              For i=1 To compt 
                valeur$ = StringField(a$,i,"/") 
                Select i
                    ;{ general
                  Case 1 ; type d'objet - voir plus haut pour le dtail de chaque type
                    \Type = 100                    
                  Case 2 ; quel type de light c'est : point, directionnal, spot
                    \LightType = Val(valeur$)
                    ;}
                    ;{ position
                  Case 3; position en X
                    \pos\x = Val(valeur$)
                  Case 4; position en Y
                    \pos\Y = Val(valeur$)
                  Case 5 ; position en Z
                    \pos\z = Val(valeur$)
                    ;}
                    ;{ color, shadow
                  Case 6
                    \Color = Val(valeur$)
                  Case 7
                    \ColorSpec = Val(valeur$)
                    
                  Case 8                    
                    \Shadow = Val(valeur$)
                    ;}
                    ;{ Rotation
                  Case 16
                    \rot\x = Val(valeur$)
                  Case 17
                    \rot\y = Val(valeur$)
                  Case 18
                    \rot\z = Val(valeur$)
                    ;}
                    ;{ size & scale
                  Case 19 ; size general
                    \size = Val(valeur$)
                  Case 20; scale x
                    \scale\x = Val(valeur$)
                  Case 21; scale y
                    \scale\y = Val(valeur$)
                  Case 22; scale z
                    \scale\z = Val(valeur$)
                    ;}               
                EndSelect
              Next i 
            EndWith
            
            ; idem for the light
            ;}
        EndSelect       
      Wend
      CloseFile(#savefile)
      
      ForEach object_temp()
        With object_temp()  
          valeur+1
          StatusBarProgress(0,2,valeur)
          Select \Type              
            Case 0 ; objet3D
              ;\MeshName$ = RemoveString(\MeshName$,".mesh")
              ;\MeshName$ = RemoveString(\MeshName$,".Mesh")
              ;\MeshName$ = RemoveString(\MeshName$,".MESH")
              If level\dir$ <>""
                ; obj\MeshName$ = level\dir$+\MeshName$;+".mesh" 
                obj\MeshName$ = \MeshName$
              Else
                obj\MeshName$ = \MeshName$+".mesh" 
              EndIf 
              obj\Name$ = \MeshName$
              If \MaterialName$ <>""
                obj\MaterialName$ = RemoveString(\MaterialName$,"data\Material\")
                obj\type = 2                 
                ForEach bibli_mat()
                  If bibli_mat()\MaterialName$ = RemoveString(\MaterialName$,"data\Material\")
                    mat_ok = 1
                    obj\MaterialId= bibli_mat()\MaterialId
                    Break
                  EndIf
                Next
                If mat_ok = 0; pas encore utilis
                  n = ListSize(bibli_mat())
                  AddElement(bibli_mat())                 
                  bibli_mat()\MaterialId = n
                  obj\MaterialId = n
                  bibli_mat()\MaterialName$ = RemoveString(\MaterialName$,"data\Material\")
                EndIf
              Else ; le material est dans le fichier mesh
                level\NbMaterial +1 
                n = level\NbMaterial  ;ListSize(bibli_mat())
                AddElement(bibli_mat())               
                bibli_mat()\MaterialId = n                 
                obj\MaterialId = n 
                obj\MaterialName$ =""
                obj\type = 3
              EndIf   
              CreateObjet(0,\Pos\X,\Pos\Y,\Pos\Z,3,\size,\rot\x,\rot\Y,\rot\Z); mode 2 = open a saved file
              
            Case 50; water
              
            Case 52 ; skydom
              
            Case 53 ; skybox
              
            Case 54; fog
              
            Case 100 ; light
              AddLight(\Color,\Pos\X,\Pos\Y,\Pos\Z,\ColorSpec,\Shadow) 
              
          EndSelect           
        EndWith        
      Next
      ClearList(object_temp())
    EndIf
  EndIf
  ReleaseMouse(0)
EndProcedure
Procedure ClearScene()
  ClearGadgetItems(#Gadget_LightList)
  ClearList(Asset())
  UpdateTreeGadget() 
  ForEach object()
    With object()
      If IsEntity(\EntityId)
        FreeEntity(\EntityId)
      EndIf
      If IsLight(\EntityId)
        FreeLight(\EntityId)
      EndIf
    EndWith
  Next
  ClearList(object())
  ClearList(bibli())
  ClearList(bibli_mat())  
  InitLevel()
EndProcedure

Procedure ExportScene()
    ; dll
  If OpenLibrary(0, "export.dll")
    CallFunction(0, "OpenScene3D")
    CloseLibrary(0)
  Else
    MessageRequester("error","Unable To open the export.dll")
  EndIf  

EndProcedure
Procedure ImportScene()
  ; dll
  If OpenLibrary(0, "export.dll")
    CallFunction(0, "SaveScene3D")
    CloseLibrary(0)
  Else
    MessageRequester("error","Unable To open the export.dll")
  EndIf  
;   file$=SaveFileRequester("Save","","*.ark",0)
;   If file$ <>""
;     If OpenFile(#savefile,RemoveString(file$,".ark")+".ark")
;       TypeObjet = 0 ; objet 3D
;       ForEach object()    
;          With object()
;           ;param$ = "ent,"+Str(\pos\x)+","+Str(\pos\y)+","+Str(\pos\z)+","+Str(\rot\x)+","+Str(\rot\y)+","+Str(\rot\z)+","
;          ; param$ +\meshName$+","+Str(\size)+","
;           ;WriteStringN(#savefile,param$)
;           WriteStringN(#savefile,"sauvegarde de l'objet N "+Str(\entityId)+", avec ses paramtres...")
;         EndWith        
;       Next       
;       CloseFile(#savefile)
;     EndIf    
;   EndIf  
EndProcedure

; bank
Procedure OpenFile2(file$,gadget,mode=0)
  If mode = 0
    fichier$="data\txt\"+option\lang$+"\"+file$
  Else
    fichier$=file$
  EndIf
  
  If ReadFile(#openfile,fichier$) 
    i=0
    While Eof(#openfile) = 0
      nom$ =ReadString(#openfile) 
      AddGadgetItem(gadget,i,nom$)
      i+1
    Wend
    CloseFile(#openfile)
  Else
    MessageRequester("Error","Unable to open the file "+fichier$)
  EndIf  
EndProcedure
Procedure OpenBankAsset()
  ClearGadgetItems(#gadget_bank_List)
  If OpenPreferences("data\txt\"+option\lang$+"\"+GbBankTheme+".ini") 
    nb = ReadPreferenceInteger("nb",0)
    For i = 0 To nb      
      obj$ = "obj"+Str(i)
      PreferenceGroup(obj$)
      nom$ = ReadPreferenceString("Nom","Name Object")
      AddGadgetItem(#gadget_bank_List,i,nom$)
    Next i    
    ClosePreferences()
  EndIf
  SetGadgetState(#gadget_bank_List,0)
EndProcedure
Procedure OpenBankTheme()
  ClearGadgetItems(#gadget_bank_Theme)
  OpenFile2(GbBankGroup+".ini",#gadget_bank_Theme)
  SetGadgetState(#gadget_bank_Theme,0)
  GbBankTheme = GetGadgetText(#gadget_bank_Theme)
  OpenBankAsset()
EndProcedure
Procedure OpenBankGroup()
  OpenFile2("group.ini",#gadget_bank_group)
  SetGadgetState(#gadget_bank_group,0)
  GbBankGroup = GetGadgetText(#gadget_bank_group)
  OpenBankTheme()
EndProcedure

Procedure OpenBankMaterial()
  OpenFile2("data\material\mat.puremat",#ObjectMaterial,1)
  SetGadgetState(#ObjectMaterial,0)
EndProcedure

;}

;{ objet : toutes les transformations pour tous les objets (object3D, light..)
Procedure Snap(X,kaz)
  ProcedureReturn Round(x/kaz,0)*kaz
EndProcedure
Procedure InitObj(id=0)
  If OpenPreferences("data\txt\"+option\lang$+"\"+GbBankTheme+".ini")
    PreferenceGroup("obj"+Str(id))
    obj\ObjetId = ReadPreferenceInteger("ObjetId",0) ; robot
    With obj
      \name$ = ReadPreferenceString("Nom","Rob")
      \type = ReadPreferenceInteger("type",0)
      If \type = 0; objet avec dfini par le fichier
        \materialName$ = "data\Material\" + ReadPreferenceString("Material","base")
        \MaterialId = ReadPreferenceInteger("MaterialId",0)
        \textureName$ = ReadPreferenceString("Texture","r2skin.jpg")
        \textureId = ReadPreferenceInteger("TextureId",0)
        \meshName$ = ReadPreferenceString("Mesh","robot.mesh")
        \meshId = ReadPreferenceInteger("MeshId",0)
      ElseIf \type = 1; objet avec material prdifini (*.material  son nom ou dans le fichier mesh)
        \dir$ = ReadPreferenceString("dir","bank\jim\")
        \materialName$ = dir$ + ReadPreferenceString("Material","bake")
        \MaterialId = ReadPreferenceInteger("MaterialId",0)
        \textureName$ = ReadPreferenceString("Texture","r2skin.jpg")
        \textureId = ReadPreferenceInteger("TextureId",0)
        \meshName$ = ReadPreferenceString("Mesh","jim.mesh")
        \meshId = ReadPreferenceInteger("MeshId",0)
      Else
        
      EndIf    
    EndWith
    ClosePreferences()
  EndIf
EndProcedure

; object utilitaires
Procedure BoundingBox()
  ForEach object()
    If object()\EntityId = GbEntity\EntityId 
      If object()\Type <> 100 And IsMesh(object()\MeshId)
        r= MeshRadius(object()\MeshId)/2 * (object()\Size)
        If r>0
          ResizeEntity(#BoundingBox,r,25,r)
        EndIf        
      Else
        ResizeEntity(#BoundingBox,30,5,30)
      EndIf    
      Break
    EndIf
  Next  
EndProcedure
Procedure UpdateObjetInfos()
  ; on update les infos sur le panel "Object"
  GbEntity\name$ = object()\name$
  SetGadgetText(#ObjectName,GbEntity\name$)
  SetGadgetText(#ObjectPosX,Str(object()\pos\x))
  SetGadgetText(#ObjectPosY,Str(object()\pos\y))
  SetGadgetText(#ObjectPosZ,Str(object()\pos\z))
  SetGadgetText(#ObjectRotX,Str(object()\rot\x))
  SetGadgetText(#ObjectRotY,Str(object()\rot\y))
  SetGadgetText(#ObjectRotZ,Str(object()\rot\z))
  SetGadgetText(#ObjectScale,Str(object()\size*10))
  SetGadgetState(#ObjectBlocked,object()\blocked)
  SetGadgetState(#ObjectCastShadow,object()\CastShadow)
  SetGadgetText(#ObjectMatname,object()\MaterialName$)
  SetGadgetText(#ObjectMeshname,object()\MeshName$)
  GbEntity\color = object()\color  
  SetGadgetState(#Gadget_Lightshadow,object()\shadow)
EndProcedure

; creation des objets
Procedure CreatePrimitive(id=0)
  AddElement(object())
  With object()
    \entityId = level\NbEntity  
    \MaterialId = level\NbMaterial    
    Select id
        
      Case 0 ; sphere        
        CreateSphere(\entityId,100,16,16)   
        \Name$ = "Sphere_"+Str(\entityId)
        
      Case 1 ; cube        
        CreateCube(\entityId,50)
        \Name$ = "Cube_"+Str(\entityId)
        
      Case 2 ; plane
        CreatePlane(\entityId,100,100,10,10,prim\TexturRepeat,prim\TexturRepeat)  
        \Name$ = "Plane_"+Str(\entityId)
        
      Case 3 ; cylindre
        CreateCylinder(\entityId,25,100)
        \Name$ = "Cylinder_"+Str(\entityId)
        
    EndSelect
    CreateEntity(\entityId,MeshID(\entityId),#PB_Material_None)
    EntityLocate(\EntityId,cible\Pos\X,cible\Pos\Y,cible\Pos\Z)
    \Selected = 1 
    GbEntity\EntityId = \EntityId
    AddAsset(\Name$,cible\Pos\X,cible\pos\y,cible\Pos\Z,0)
  EndWith
  level\NbEntity + 1
  level\NbMaterial + 1 
  UpdateObjetInfos()
  UpdateListSelect()
EndProcedure
Procedure CreateObjet(id=0,x=0,y=0,z=0,mode=0,siz.d=1,rotx=0,roty=0,rotz=0,sel=0) 
  If ReadFile(0,"data\Models\"+obj\MeshName$) Or ReadFile(0,obj\MeshName$) Or mode = 3
    If mode <> 3
      CloseFile(0)
    EndIf
    AddElement(object()) 
    With object() 
      Select id
        Case 0 ;{ objet           
          ForEach bibli()
            ;on vrifie si on a dj utilis le mme mesh
            If bibli()\meshName$ = obj\meshName$ ; on a dj utilis cet objet (mme mesh, texture et material)              
              ;\ObjetId = bibli()\ObjetId  
              Debug "objet trouv"
              \MeshId = bibli()\MeshId
              \MeshName$ = bibli()\MeshName$        
              \EntityId = level\NbEntity 
              \Name$ = bibli()\Name$
              \Type = bibli()\Type
              \Center = bibli()\Center
              \MaterialId = bibli()\MaterialId
              \MaterialName$ = bibli()\MaterialName$        
              \TextureId = bibli()\TextureId
              \TextureName$ = bibli()\TextureName$
              ok = 1
              Break     
            EndIf
          Next
          
          ForEach bibli_mat()
            If bibli_mat()\MaterialName$ = obj\MaterialName$
              \MaterialId = bibli_mat()\MaterialId
              \MaterialName$ = bibli_mat()\MaterialName$        
              \TextureId = bibli_mat()\TextureId
              \TextureName$ = bibli_mat()\TextureName$    
              ok_mat = 1
              Break              
            EndIf            
          Next
          
          If ok = 0 ; on n'a jamais utilis cet objet3D
            Debug "objet non trouv, on l'ajoute"
            ; d'abord on l'ajoute  la bibliotheque
            AddElement(bibli())
            ; gnralit sur l'objet
            bibli()\name$ = obj\name$
            bibli()\ObjetId = obj\ObjetId ; plus utilis ??             
            ; material
            bibli()\MaterialId= obj\MaterialId
            bibli()\materialName$= obj\materialName$ 
            \materialId = obj\MaterialId            
            \materialName$ = obj\materialName$
            level\NbMaterial + 1
            ; textures
            bibli()\textureId = obj\textureId
            bibli()\textureName$ = obj\textureName$
            \textureId = obj\textureId
            \textureName$ = obj\textureName$
            level\NbTexture + 1
            ; mesh
            bibli()\meshName$ = obj\MeshName$
            bibli()\MeshId = \MeshId  
            \meshName$ = obj\meshName$   
            \meshId = level\NbMesh
            level\NbMesh + 1             
            LoadMesh(\meshId, \meshName$) ;LoadMesh(\meshId, \meshName$)
            ; center of the mesh
            bibli()\Center = MeshRadius(\meshId)/2 
            ; il faut le type pour juste en dessous
            bibli()\Type = obj\Type
            \type = obj\type 
            ; puis, on cre l'entity avec tous les paramtres, en fonction de type d'objet
            If \type = 0
              CreateMaterial(\materialId, LoadTexture(\textureId, \textureName$))  
            ElseIf \type = 2
              CreateMaterial(\materialId, LoadTexture(1, "env_room.jpg")) 
            EndIf            
          EndIf
          \type = obj\type ; on doit le remettre si on ne passe pas par ok =1
          ; on dfinit ce qui est ncesasire pour crer les entit
          \entityId = level\NbEntity            
          Debug "EntId : "+Str(\EntityId)+" - mat ID :"+Str(\MaterialId) + "/ " + \MaterialName$ + " / Mesh Id : "+Str(\MeshId)+"/ mesh : "+\MeshName$
          ; puis on cr l'entit
          If \type =0                    
            CreateEntity(\entityId, MeshID(\meshId), MaterialID(\materialId))
          ElseIf \type = 1 Or \type = 3; on a charg un objet avec le material dans le .mesh  
            ; ou on ouvre une scne et le material est dans le .mesh, donc on n'a pas de \materialname$       
            CreateEntity(\entityId, MeshID(\meshId), #PB_Material_None)
          ElseIf \type = 2 ; on a enregistr le material dans le fichier de sauvegrade de la scene 
            CreateEntity(\entityId, MeshID(\meshId), #PB_Material_None) 
            ;\MaterialId = GetScriptMaterial(#PB_Any,\MaterialName$) 
            GetScriptMaterial(\MaterialId,\MaterialName$) 
            SetEntityMaterial(\entityId,MaterialID(\MaterialId))                  
          EndIf
          ;{ les autres paramtres
          \TypeObjet = 0; objet 3D                  
          \name$ = obj\name$+"_"+ Str(\EntityId)  
          \Center = MeshRadius(\meshId)/2         
          ; position
          EntityLocate(\entityId,x,y,z)
          \Pos\X = x
          \Pos\Y = y
          \Pos\Z = z
          ; on le scale
          ScaleEntity(\entityId,siz,siz,siz)
          \Size = siz
          If camera\ScaleOk And mode <>2 ; open a file
            \Size = camera\meshscale
            ScaleEntity(\entityId,camera\meshscale,camera\meshscale,camera\meshscale)
          EndIf 
          ; rotation
          \Rot\X = rotx
          \Rot\Y = roty
          \Rot\Z = rotz
          RotateEntity(\entityId,\Rot\X,\Rot\Y,\Rot\Z)
          ; selection de l'objet ?
          If camera\SelectEntity
            GbEntity\entityId = \entityId
          EndIf 
          \Selected= sel 
          ;autre proprits shadow
          \CastShadow = option\autoShadow
          EntityRenderMode(\EntityId,3+option\autoShadow)
          BuildMeshShadowVolume(\meshId)
          ;}          
          ;{ creation des gadget de selection et updates
          level\NbObjet + 1
          AddAsset(\Name$,\Pos\X,\pos\y,\Pos\Z,0)          
          UpdateTreeGadget()
          UpdateListSelect() ;}
          ;}
        Case 1 ;{ light
;           \color = Gbcolor
;           \entityId = n
;           \pos\x = Cible\pos\x
;           \pos\y = Cible\pos\y
;           \pos\z = Cible\pos\z
          ;CreateLight(n,Gbcolor,Cible\pos\x,Cible\pos\y,Cible\pos\z,#PB_Light_Point)
          ;}
        Case 2 ;{ particules
          ;}
        Case 3 ;{ terrain
          ;}
        Case 4 ;{ water
          ;}
        Case 5 ;{ camera
          ;}
        Case 6 ;{ SphereSkydom
          ;}
      EndSelect
    EndWith
    level\NbEntity+1 
  Else
    If mode = 1
      MessageRequester("Error","The file doesn't exist or has to be in the 'data\Models\' directory before To be loaded."+Chr(13)+"If you add a *.mesh in this directory, you'll have to restart the Program.")
    Else
;       If MessageRequester("Error","The file doesn't exist."+Chr(13)+"Do you want to open it manually ?",#PB_MessageRequester_YesNo) =6
;         Filtre$ = "Mesh (*.mesh)|*.mesh"
;         mesh$ = OpenFileRequester("Model 3D",obj\MeshName$,filtre$,0)
;         If mesh$ <> "" And GetExtensionPart(mesh$)="mesh"
;           ;mesh$=GetFilePart(mesh$)
;           obj\MeshName$ = mesh$
;           obj\type=1
;           level\NbreMaterial+1
;           obj\MaterialId = level\NbreMaterial          
;           CreateObjet(0,0,0,0,1)          
;         EndIf      
;       EndIf
    EndIf
  EndIf
EndProcedure

; modify
Procedure SetInfoObjet(id=0,mode=0,val=0)
  ForEach object()
    With object()     
      If \Selected = 1 ;\entityId = GbEntity\entityId
        If \blocked = 0 And \Hide = 0
          ;{ snap
          If camera\snapOk
            ; pick mouse
            xxx = Snap(PickX(),camera\snap\X)
            yyy = Snap(PickY(),camera\snap\Y) 
            zzz = Snap(PickZ(),camera\snap\Z) 
            ; mousedelta
            \pos\x  + MouseDeltaX() * #CameraSpeed          
            mouseX = snap(\pos\x,camera\Snap\X)
            \pos\Y - MouseDeltaY() * #CameraSpeed        
            mouseY = snap(\pos\Y,camera\Snap\Y)
            \pos\Z + (MouseDeltaY() * #CameraSpeed - MouseDeltaX() * #CameraSpeed)/2
            MouseZ = snap(\pos\Z,camera\Snap\Z)
          Else
            ; pick
            xxx = PickX()
            yyy = PickY()
            zzz = PickZ()
            ; mouse delta
            mouseX = EntityX(\entityId) + MouseDeltaX() * #CameraSpeed 
            mouseY = EntityY(\entityId) - MouseDeltaY() * #CameraSpeed
            mouseZ = EntityZ(\entityId) + (MouseDeltaY() * #CameraSpeed  - MouseDeltaX() * #CameraSpeed )/2 
            
          EndIf
          ;}
          If option\axeMouse; mode de dplacement suivant le mousedelta et non le pickmouse, pickx(), picky(), pickZ().
            Select mode 
                
              Case 1  ; move  souris    
                Select camera\Axe
                  Case 0 ; x                  
                    EntityLocate(\entityId,mouseX ,EntityY(\entityId),EntityZ(\entityId))                  
                  Case 2 ; Z : attention c'est invers avec Y.
                    EntityLocate(\entityId,EntityX(\entityId),mouseY,EntityZ(\entityId))
                  Case 1 ; Y                 
                    EntityLocate(\entityId,EntityX(\entityId),EntityY(\entityId),mouseZ)
                  Case 3 ; xy
                    EntityLocate(\entityId,mouseX,mouseY,EntityZ(\entityId))
                  Case 4 ; xz
                    EntityLocate(\entityId,mouseX,EntityY(\entityId),mouseZ)
                  Case 5 ; yz
                    EntityLocate(\entityId,EntityX(\entityId),mouseY,mouseZ)                          
                EndSelect
                
              Case 2 ; size souris
                a.f =\size
                If a + 0.005*val >0.005              
                  a + 0.005*val
                  a${5} = StrD(a)
                  \size = ValD(a$)
                  ResizeEntity(\entityId, \size, \size, \size) 
                EndIf
                
              Case 3 ; rotate souris
                Key_Y =  MouseDeltaY() * 0.5
                Key_X = - MouseDeltaX() * 0.5     
                RotateEntity(\entityId, 0, Key_Y, 0, #PB_Relative)
                
              Case 4 ; rotate gadget
                RotateEntity(\entityId, 0, val, 0, #PB_Relative)
                
              Case 7 ; size gadget
                If val >0
                  \size = val/10
                  ResizeEntity(\entityId,\size,\size,\size) 
                EndIf
                
              Case 11; move gadget X
                EntityLocate(\EntityId,val,EntityY(\entityId),EntityZ(\entityId))
                
              Case 12; move gadget Y
                EntityLocate(\EntityId,EntityX(\entityId),EntityY(\entityId),val)
                
              Case 13; move gadget Z
                EntityLocate(\EntityId,EntityX(\entityId),val,EntityZ(\entityId))
            
            EndSelect 
          Else          
            Select mode 
              Case 1    ; move      
                Select camera\Axe
                  Case 0 ; x
                    EntityLocate(\entityId,xxx,EntityY(\entityId),EntityZ(\entityId))                  
                  Case 2 ; y
                    EntityLocate(\entityId,EntityX(\entityId),yyy,EntityZ(\entityId))
                  Case 1 ; Z
                    EntityLocate(\entityId,EntityX(\entityId),EntityY(\entityId),zzz)
                  Case 3 ; xy
                    EntityLocate(\entityId,xxx,yyy,EntityZ(\entityId))
                  Case 4 ; xz
                    EntityLocate(\entityId,xxx,EntityY(\entityId),zzz)
                  Case 5 ; yz
                    EntityLocate(\entityId,EntityX(\entityId),yyy,zzz)                          
                EndSelect
              Case 2 ; size
                a.f =\size
                If a + 0.005*siz >0.005              
                  a + 0.005*siz
                  a${5} = StrD(a)
                  \size = ValD(a$)
                  ResizeEntity(\entityId, \size, \size, \size) 
                EndIf
            EndSelect 
          EndIf   
          If camera\snapOk=0
            \pos\x = EntityX(\entityId)
            \pos\y = EntityY(\entityId)
            \pos\z = EntityZ(\entityId)
          EndIf
          \rot\x = EntityPitch(\entityId)
          \rot\y = EntityYaw(\entityId)
          \rot\z = EntityRoll(\entityId)
          If \type = 100   
            LightLocate(\entityId,EntityX(\entityId),EntityY(\entityId),EntityZ(\entityId))           
          EndIf 
        EndIf
        If \entityId = GbEntity\entityId And mode <4
          UpdateObjetInfos()
        EndIf
      EndIf     
    EndWith    
  Next 
  BoundingBox()
EndProcedure
Procedure ModifyObjet(id=0,val=0)
  SetInfoObjet(id)
EndProcedure
; delete
Procedure DeleteObjet()  
  ForEach object()
    With object()
      If \Selected = 1
        If \Type = 100 ; light                  
          FreeLight(\entityId)
        EndIf
        FreeEntity(\entityId)
        DeleteElement(object(),1)
        GbEntity\EntityId = -1
        ;Break      
      EndIf      
    EndWith
  Next 
  ClearGadgetItems(#Gadget_LightList)
  n = 0
  ForEach object()
    With object()
      If \Type = 100        
        AddGadgetItem(#Gadget_LightList,n,\name$)
        n+1
      EndIf
    EndWith    
  Next
  UpdateListSelect()
EndProcedure
; hide
Procedure HideObj()
  ForEach object()
    With object()
      If \selected =1 And \type <10
        HideEntity(\entityId,1)        
      EndIf      
    EndWith
  Next
EndProcedure
Procedure UnhideAll()
  ForEach object()
    With object() 
      If IsEntity(\EntityId)
        HideEntity(\EntityId,0)
      EndIf
      If IsLight(\EntityId)
        HideLight(\EntityId,0)
      EndIf      
    EndWith
  Next
EndProcedure
; properties
Procedure ObjCastShado(val)
  ForEach object()
    With object()
      If \entityId = GbEntity\entityId
        \castshadow = val
        If val = 1
          EntityRenderMode(\entityId,#PB_Entity_CastShadow)
        Else
          EntityRenderMode(\entityId,#PB_Material_None)
        EndIf        
        Break
      EndIf      
    EndWith
  Next
EndProcedure
Procedure ObjectName(nom$)
  ForEach object()
    If GbEntity\EntityId = object()\EntityId
      object()\Name$ = nom$
      Break
    EndIf    
  Next  
EndProcedure
; selection
Procedure SelectObject(entity)
  ForEach object()
    If object()\EntityId = entity
      object()\Selected = 1
      If option\ModeSelection And object()\type =0
        If IsMaterial(object()\MaterialId)
          MaterialBlendingMode(object()\MaterialId,1)  
        EndIf        
      EndIf        
      Break
    EndIf
  Next 
EndProcedure
Procedure SelectAllObject(mode=1)  
  ForEach object()
    With object()
      If \TypeObjet = TypeObjet Or mode = 0    
        \Selected = mode
        If option\ModeSelection
          If IsMaterial(\MaterialId)
            If \Selected = 1
              MaterialBlendingMode(\MaterialId,1)        
            Else
              MaterialBlendingMode(\MaterialId,0)             
            EndIf            
          EndIf
        EndIf
        If GbEntity\entityId <=0
          GbEntity\entityId = \EntityId
        EndIf        
      EndIf
    EndWith    
  Next  
EndProcedure
Procedure ObjectSelect(nom$)
  SelectAllObject(0)  
  ForEach object()
    With object()
      If \Name$ = nom$ 
        GbEntity\EntityId = \EntityId
        \Selected = 1
        UpdateObjetInfos()       
        Break
      EndIf 
    EndWith
  Next 
  BoundingBox()
EndProcedure
Procedure SetObjectSelectionMode()
  ForEach object()    
    If object()\Selected = 1 And object()\type <>100
      If IsMaterial(object()\MaterialId)
        If option\ModeSelection 
          MaterialBlendingMode(object()\MaterialId,1)   
        Else
          MaterialBlendingMode(object()\MaterialId,0)   
        EndIf 
      EndIf
    EndIf
  Next 
EndProcedure
; freeze
Procedure FreezeAll(mode=0)
  ForEach object()
    object()\blocked = mode
  Next  
EndProcedure
Procedure FreezeObject(mode=0)
  ForEach object()
    If object()\Selected = 1
      object()\blocked = mode
    EndIf
  Next  
EndProcedure
; copy
Procedure DuplicatedObject()
  ForEach object()
    With object()
      If \Selected = 1 And \type<> 100
        \selected = 0
        AddElement(object_temp())        
        object_temp()\MaterialId = \MaterialId
        object_temp()\MaterialName$ = \MaterialName$
        object_temp()\MeshId = \MeshId
        object_temp()\MeshName$ = \MeshName$        
        object_temp()\Pos\X = \Pos\X
        object_temp()\Pos\Y = \Pos\Y
        object_temp()\Pos\Z = \Pos\Z
        object_temp()\Rot\X = \Rot\X
        object_temp()\Rot\Y = \Rot\Y
        object_temp()\Rot\Z = \Rot\Z
        object_temp()\Size = \Size 
        object_temp()\Type = \Type 
      EndIf
    EndWith
  Next  
  ForEach object_temp()
    With object_temp()
      obj\MaterialId = \MaterialId
      obj\MaterialName$ = \ MaterialName$
      obj\MeshId = \ MeshId
      obj\MeshName$ = \MeshName$  
      obj\type = \Type
      obj\Name$ = \MeshName$ 
      CreateObjet(0,\Pos\X,\Pos\Y,\Pos\Z,0,\Size,\Rot\X,\Rot\Y,\Rot\Z,1) 
    EndWith    
  Next
  ClearList(object_temp())
  GbtransformObject = 2
  GbtransformOk = 1
EndProcedure

; load material & mesh
Procedure ChangeObjectMaterial(material$)
  ForEach object()
    With object()
      If \EntityId = GbEntity\entityId  
        If IsMaterial(\MaterialId)
          Debug "l'objet a un material"
          Debug "le mat  charger :" +material$
          If GetScriptMaterial(\MaterialId,material$) 
            Debug "le script mat est bien charg : " + material$
            \MaterialName$ = material$
            If SetEntityMaterial(\entityId,MaterialID(\MaterialId))
              Debug "on a mis le mat sur l'objet"
            EndIf
          EndIf        
        Else
          Debug "l'objet n'a pas de material, on le cr"
          level\NbMaterial+1
          \MaterialId = level\NbMaterial
          If GetScriptMaterial(\MaterialId, material$) 
            Debug "le script est bien charg"
            \MaterialName$ = material$
            SetEntityMaterial(\entityId,MaterialID(\MaterialId))
          EndIf
        EndIf
        Break
      EndIf
    EndWith
  Next
EndProcedure
Procedure MaterialLoad()
  dir$=dir("data\Material\")
  mat$=OpenFileRequester("Get a Material",dir$,"*.material",0)
  If mat$ <>"" 
    If GetExtensionPart(mat$)="material"
      mat$=RemoveString(GetFilePart(mat$),".material")    
      ChangeObjectMaterial(mat$)
    Else   
      MessageRequester("Error","Please, select a valid *.material")
    EndIf
  EndIf
EndProcedure
Procedure MeshLoad()  
  Filtre$ = "Mesh (*.mesh)|*.mesh"
  dir$=dir("data\Models\")
  mesh$ = OpenFileRequester("Model 3D",dir$,filtre$,0)
  If mesh$ <> "" And (GetExtensionPart(mesh$)="mesh" Or GetExtensionPart(mesh$)="Mesh" Or GetExtensionPart(mesh$)="MESH")
    If GetPathPart(mesh$) = GetCurrentDirectory() + "data\Models\"
      mode = 1
    Else
      mode = 3
    EndIf   
    mesh$=GetFilePart(mesh$)
    obj\MeshName$ = mesh$
    obj\Name$ = RemoveString(RemoveString(RemoveString(mesh$,"mesh"),"MESH"),"Mesh")
    obj\Name$ = RemoveString(obj\Name$,".")
    obj\MaterialName$ = ""
    obj\type = 1
    level\NbMaterial+1
    obj\MaterialId = level\NbMaterial
    level\NbMesh+1
    obj\MeshId = level\NbMesh    
    CreateObjet(0,0,0,0,mode) 
  EndIf      
EndProcedure
Procedure DirLoad()
  ; chargement d'un rpertoire complet, avec tous les mesh contenus dans celui-ci
  Filtre$ = "Mesh (*.mesh)|*.mesh;*.Mesh;*.MESH"
  dir$=GetCurrentDirectory() + dir("data\Models\")
  Directory$ = PathRequester("Choose the directory",dir$)
  If Directory$ <>""
    If ExamineDirectory(0, Directory$, "*.*") 
      While NextDirectoryEntry(0)
        If DirectoryEntryType(0) = #PB_DirectoryEntry_File
          mesh$ = DirectoryEntryName(0)
          If mesh$ <> "" 
            If (GetExtensionPart(mesh$)="mesh" Or GetExtensionPart(mesh$)="Mesh" Or GetExtensionPart(mesh$)="MESH")
              mode = 3
              mesh$=GetFilePart(mesh$)
              obj\MeshName$ = mesh$
              obj\Name$ = RemoveString(RemoveString(RemoveString(mesh$,"mesh"),"MESH"),"Mesh")
              obj\Name$ = RemoveString(obj\Name$,".")
              obj\MaterialName$ = ""
              obj\type = 1
              level\NbMaterial+1
              obj\MaterialId = level\NbMaterial
              level\NbMesh+1
              obj\MeshId = level\NbMesh    
              CreateObjet(0,0,0,0,mode)  
            Else 
              MessageRequester("Error","The extension autorised are : mesh, Mesh and MESH")
            EndIf
         EndIf      
        EndIf
      Wend
      FinishDirectory(0)    
    EndIf 
  EndIf
EndProcedure

; Light
Procedure AddLight(color=#White,x=0,y=0,z=0,spec=#White,shado=1,Ltyp=0)
  n = level\NbLight
  AddElement(object())  
  With object()
    \pos\x = x
    \pos\y = y
    \pos\z = z
    \color = color
    \ColorSpec = spec
    \entityId = level\NbEntity
    \name$ = "Light"+Str(level\NbLight)
    \Type = 100
    \TypeObjet = 1
    \shadow = shado 
    \LightType = Ltyp
    \MaterialId = #UIMatLight
    CreateEntity(\entityId,MeshID(#UiMeshLight),MaterialID(\MaterialId))
    EntityRenderMode(\entityId,#PB_Entity_None)
    EntityLocate(\entityId,x,y,z)
    
    CreateLight(\entityId,color,x,y,z,Ltyp)
    LightLookAt(\entityId,0,0,0)
    
    ;CreateLight(4,color,x,y,z,Ltyp)
    ;LightColor(4,#White,#PB_Light_SpecularColor); erreur aussi IMA
    
    ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< ERROR IMA LIGHTCOLOR()
    ;LightColor(\entityId,spec,#PB_Light_SpecularColor); pb4.61 b3 et b4 : erreur IMA
    
    ; mme comme a, on a une erreur : 
    ;LightColor(4,#White,#PB_Light_SpecularColor); erreur aussi IMA
    
    ; test pour version pb 4.61 b2 : comme a avec pb4.61b2 , aucun soucis
    ;LightSpecularColor(\entityId,spec) ; pour pb 4.61b2 : c'est ok
    
    
    DisableLightShadows(\entityId,1-shado)
    AddGadgetItem(#Gadget_LightList,n,\name$)
    AddAsset(\Name$,\pos\X,\pos\Y,\pos\Z,2); on ajoute une entre dans le treegadget  gauche (pas termin)
  EndWith
  level\NbEntity + 1
  level\NbObjet + 1
  level\NbLight + 1
  UpdateTreeGadget()
EndProcedure
Procedure LightDefaut()
  GetScriptMaterial(#UIMatLight,"light")  
  CreateSphere(#UiMeshLight,10,6,6)  
  AddLight(RGB(0, 0, 255),200,200,0)
  AddLight(RGB(255, 0, 0),-100,200,0)
  AddLight(RGB(237, 153, 23),100,400,400)
EndProcedure
Procedure LightSetColor(gadget)
  
  ;****************** explication pour Fred ************************
  
  ; pour utiliser ce gadget, il faut : 
  ; -cliquer sur le panel "light"
  ; - dans la liste view slectionner une light
  ; - et cliquer sur le bouton "color" ou "speccolor"
  
  ForEach object()
    With object()
      If \entityId = GbEntity\entityId
        If IsLight(\entityId)           
          If gadget = #Gadget_LightColorBtn
            \color =ColorRequester(\color)
             ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< ERROR IMA LIGHTCOLOR()
             ; si tu slectionnes une light et que tu changes sa couleur diffuse (dans le panel light, cliquez sur le bouton color, 
             ; a provoque une ima aussi
            LightColor(\entityId,\color,#PB_Light_DiffuseColor);pb 4.61b3 et b4 : erreur IMA
            
            ;LightDiffuseColor(\entityId,\color) ; pb 4.61b2 : c'est ok
            
          ElseIf gadget =#Gadget_LightColorSpecBtn
            \ColorSpec =ColorRequester(\colorspec)
                ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< ERROR IMA LIGHTCOLOR()
            LightColor(\entityId,\colorspec,#PB_Light_SpecularColor);pb 4.61b3 et b4 : erreur IMA
            
            ;LightSpecularColor(\entityId,\colorspec) ; pb 4.61b2 : c'est ok
            
          EndIf          
        EndIf        
        Break
      EndIf      
    EndWith
  Next
EndProcedure
Procedure LightSetShadow(shado)
  ForEach object()
    With object()
      If \entityId = GbEntity\entityId
        \shadow = shado
        If \type =100
          DisableLightShadows(\entityId,1-shado)
          \shadow = shado
          Break
        EndIf      
      EndIf
    EndWith
  Next
EndProcedure
Procedure LightHide()
  ForEach object()
    With object() 
      If \type  = 100
        HideLight(\entityId,option\LightActive)
        HideEntity(\entityId,option\LightActive)
      EndIf
    EndWith  
  Next 
EndProcedure

; World 
Procedure CreateSkydom()
  ForEach object()
    If object()\Type = 52
      ok = 1
      Break
    EndIf
  Next
  If ok = 0
    SkyDome(world\Skydom\SkyImg$,world\Skydom\SkyCurve)
    AddElement(object()) 
    object()\Type = 52
  EndIf  
EndProcedure
Procedure CreateSkyBox()
  ForEach object()
    If object()\Type = 53
      ok = 1
      Break
    EndIf
  Next
  If ok = 0
    Add3DArchive("data/Packs/desert.zip", #PB_3DArchive_Zip)
    SkyBox("desert07.jpg")
    AddElement(object()) 
    object()\Type = 53
  EndIf  
EndProcedure

; temporaire -  supprimer par la suite -
Procedure CreateBoundingBoxRect()
  CreateCube(#MeshBoundingBox,1)
  CreateMaterial(#UI_matselect, LoadTexture(#UiTxSelect, "select.png"))
  MaterialBlendingMode(#UI_matselect,#PB_Material_AlphaBlend)
  CreateEntity(#BoundingBox,MeshID(#MeshBoundingBox),MaterialID(#UI_matselect),0,0,0)
  EntityRenderMode(#BoundingBox,#PB_Material_None)
  level\NbEntity+1
  level\NbMaterial +1
  level\NbMesh +1
EndProcedure
Procedure Teapot()
nomMesh.s = "teapot.mesh"
nomMat.s = "bump_m.material"
numMaterial = 250
GetScriptMaterial(numMaterial,nomMat)

numMesh = 250
LoadMesh(numMesh , nomMesh)
If IsMesh(numMesh) = #False
  numMesh = CreateSphere(#PB_Any,1)
  BuildMeshShadowVolume(numMesh)
EndIf 
CreateEntity(100,MeshID(numMesh),MaterialID(numMaterial))
ScaleEntity(100,10,10,10)

EndProcedure
Procedure addJim()
;   AddElement(bibli())
;   bibli()\ObjetId = obj\ObjetId
;   bibli()\meshId = obj\meshId
;   bibli()\meshName$ = obj\meshName$      
;   bibli()\MaterialId= obj\MaterialId
;   bibli()\materialName$= obj\materialName$      
;   bibli()\textureId = obj\textureId
;   bibli()\textureName$ = obj\textureName$ 
;   bibli()\name$ = obj\name$
If #version_pourblendman=1
  AddElement(object()) 
  With object()   
    \name$ = "Jim"
    \Type = 0
    jim_m=LoadMesh(#PB_Any, "Jim.mesh")
    ;jim_mat = GetScriptMaterial(#PB_Any, "data\bank\jim\bake.material")
    GetScriptMaterial(2000,"bake") 
    CreateEntity(level\NbEntity, MeshID(jim_m), MaterialID(2000))
    BuildMeshShadowVolume(jim_m)
    ScaleEntity(level\NbEntity,3,3,3)
    EntityRenderMode(level\NbEntity,#PB_Entity_CastShadow)
    EntityLocate(level\NbEntity,0,43,0)
    \entityId = level\NbEntity 
    \meshId = jim_m
    \Center = MeshRadius(jim_m)/2 
  EndWith  
Else
  AddElement(object()) 
  With object()   
    \name$ = "Robot"
    \Type = 0
    \Size = 1
    jim_m=LoadMesh(#PB_Any, "robot.mesh")
    \MaterialId = level\NbMaterial
    level\NbMaterial+1
    GetScriptMaterial(\MaterialId,"robot") 
    CreateEntity(level\NbEntity, MeshID(jim_m), MaterialID(\MaterialId))
    BuildMeshShadowVolume(jim_m)
    EntityRenderMode(level\NbEntity,#PB_Entity_CastShadow)
    \CastShadow = 1
    \MeshName$ = "robot.mesh"
    \MaterialName$ = "robot"    
    \entityId = level\NbEntity 
    \meshId = jim_m
    \Center = MeshRadius(jim_m)/2     
  EndWith
EndIf
level\NbEntity+1
GbEntity\EntityId = -1
EndProcedure
;}

;{ event

Procedure GestionMouse()
  If inscreen = 1
    If (MouseX()<2 XOr MouseX()>(ScreenWidth-14)) Or (MouseY()>ScreenHeight-4 XOr MouseY()<1+#TopEspace)
      inscreen = 0 ; on n'est plus dans l'cran
      ReleaseMouse(1); on libre la souris pour les menus
    EndIf      
  Else
    mx = WindowMouseX(0)-#PanoObjet-10 : my = WindowMouseY(0)-#TopEspace-3
    If (mx>#PanoObjet+10 And mx <ScreenWidth-14 And my>3+#TopEspace  And my<ScreenHeight-4)
      ReleaseMouse(0)   ; on est dans la vue 3D    
      MouseLocate(mx,my) 
    EndIf    
    inscreen = 1    
  EndIf
  StatusBarText(#StatusBar,1, Str(WindowMouseX(0))+"/"+Str(WindowMouseY(0))+" - "+Str(MouseX())+"/"+Str(MouseY()))
  StatusBarText(#StatusBar,2, "Triangles : "+Str(CountRenderedTriangles()));+" / FPS :"+Str(count))
  SetCameraProp()
EndProcedure

Macro CheckOption(opt, menu)
  opt = 1 - opt
  SetMenuItemState(0,menu,opt) 
EndMacro

; tous les events (gadget, menu, fentre..)
Procedure.a Screen3DEvents()
  Repeat    
    Event = WindowEvent()    
    Window = EventWindow()
    
    Select Window
        
      Case #WindowMain
        ;{ window principale
        If event = #PB_Event_Gadget ;And inscreen = 0
          Select EventGadget()
              ;{ toolbar
;             Case #Gadget_Snap
;               Debug "snp!!!"
;               camera\snapOk = GetGadgetState(#Gadget_Snap)
              ;}
              ;{ scene
            Case #Treegadget_Scene
              Select EventType()
                  
                Case #PB_EventType_LeftClick
                  CheckProperty(GetGadgetText(#Treegadget_Scene))
                  
                Case #PB_EventType_RightClick               
                  DisplayPopupMenu(1,WindowID(0))
                  
                Case #PB_EventType_DragStart ; drag
                  sItem = GetGadgetState(#Treegadget_Scene)                 
                  If GetGadgetItemAttribute(#Treegadget_Scene,sItem,#PB_Tree_SubLevel)>0  
                    sText.s = GetGadgetItemText(#Treegadget_Scene, sItem)
                    ForEach asset()
                      If asset()\names$ = sText
                        sType = asset()\type                       
                        Break
                      EndIf
                    Next    
                    DragPrivate(#Drop_Private, #PB_Drag_Move)  
                  EndIf    
                  
              EndSelect
              
              ;}
              ;{ objet
            Case #ObjectVisibility 
              HideObj()
              
            Case #ObjectCastShadow
              v= GetGadgetState(#ObjectCastShadow)           
              ObjCastShado(v)
              
            Case #ObjectBlocked
              mode =GetGadgetState(#ObjectBlocked)
              FreezeObject(mode)
              
            Case #ObjectMaterial             
              material$ = GetGadgetText(#ObjectMaterial)
              ChangeObjectMaterial(material$)
              
            Case #ObjectLoadMaterial
              MaterialLoad()
              
            Case #ObjectScale
              val = GetGadgetState(#ObjectScale)
              SetInfoObjet(0,7,val)
              
            Case #ObjectPosX,#ObjectPosY,#ObjectPosZ
              val = GetGadgetState(#ObjectScale)
              SetInfoObjet(0,EventGadget()-2,val)
              
            Case #ObjectRotX,#ObjectRotY,#ObjectRotZ
              val = GetGadgetState(#ObjectScale)
              SetInfoObjet(0,4,val)
              
            Case #ObjectName
              Select EventType()
                Case #PB_EventType_Focus
                  GBFocusGadget = 1
                  RemoveShortcut()
                  
                Case #PB_EventType_Change               
                  n$ = GetGadgetText(#ObjectName)
                  ObjectName(n$)
                  
                Case #PB_EventType_LostFocus
                  GBFocusGadget = 0
                  AddKeyboardShortcutMenu()
                  
              EndSelect
              
              ;}
              ;{ Light
            Case #Gadget_LightColorBtn,#Gadget_LightColorSpecBtn           
              LightSetColor(EventGadget())  
              
            Case #Gadget_LightList
              n$ = GetGadgetText(#Gadget_LightList)
              ObjectSelect(n$)
              
            Case #Gadget_LightLocate
              x = Val(InputRequester("Position en X","Position en X","0"))
              y = Val(InputRequester("Position en Y","Position en Y","0"))
              z = Val(InputRequester("Position en Z","Position en Z","0"))
              LightLocate(GbEntity\entityId,x,y,z)
              EntityLocate(GbEntity\entityId,x,y,z)
              
            Case #Gadget_Lightshadow
              LightSetShadow(GetGadgetState(#Gadget_Lightshadow))
              
              ;}
              ;{ camera
            Case #CameraFov
              fov=GetGadgetState(#CameraFov)
              CameraFOV(GbCamera,fov)
              
            Case #cameraMode
              MessageRequester("Info", "Non fonctionnel (bug pb ;))")
              mode = GetGadgetState(#cameraMode)
              ;CameraProjectionMode(#CameraGame,mode) ; si on dcommente, on a un bug
              
            Case #cameraLookAt
              camera\LookAt = GetGadgetState(#cameraLookAt)
              
            Case #camera_FactorMove
              factor = GetGadgetState(#camera_FactorMove)
              fact${6} = StrD(factor/10000)
              Debug fact$
              camera\FactorMove = ValD(fact$)
              ;}  
              ;{ bank
            Case #gadget_bank_Group
              GbBankGroup = GetGadgetText(#gadget_bank_Group)
              OpenBankTheme()
              
            Case #gadget_bank_Theme
              GbBankTheme = GetGadgetText(#gadget_bank_Theme)
              OpenBankAsset()
              
            Case #gadget_bank_List
              InitObj(GetGadgetState(#gadget_bank_List))
              ;}            
              ;{ mesh
            Case #gadget_Mesh_lookat
              camera\LookAt = GetGadgetState(#gadget_Mesh_lookat)
              
            Case #gadget_Mesh_Select          
              camera\SelectEntity = GetGadgetState(#gadget_Mesh_Select)
              
            Case #gadget_Mesh_ScaleOk
              camera\scaleok = GetGadgetState(#gadget_Mesh_ScaleOk)
              
            Case #gadget_Mesh_scale
              camera\meshscale = GetGadgetState(#gadget_Mesh_scale)
              
            Case #gadget_bank_LoadMesh          
              Meshload()
              
            Case #gadget_bank_LoadDir
              DirLoad()
              ;}
              ;{ Action
            Case #Gadget_ActionType
              act=GetGadgetState(#Gadget_ActionType)
              GadgetAction(act)
              
              ;}
              ;{ option
            Case #Gadget_WorldShadow
              World\shadowType = GetGadgetState(#Gadget_WorldShadow)
              WorldShadows(World\shadowType,world\ShadowDistance)
              
            Case #Gadget_ViewZoom
              option\ViewZoom = GetGadgetState(#Gadget_ViewZoom)
              
            Case #Gadget_MouseAxe
              option\axeMouse = GetGadgetState(#Gadget_MouseAxe)
              
            Case #Gadget_autoshadow
              option\autoShadow = GetGadgetState(#Gadget_autoshadow)
              
            Case #Gadget_Axe
              camera\Axe = GetGadgetState(#Gadget_Axe)
              
            
              
            Case #Gadget_SnapX          
              Select EventType()
                Case #PB_EventType_Focus
                  GBFocusGadget = 1
                  RemoveShortcut()
                  
                Case #PB_EventType_Change               
                  camera\snap\X = GetGadgetState(#Gadget_SnapX)
                  
                Case #PB_EventType_LostFocus
                  GBFocusGadget = 0
                  AddKeyboardShortcutMenu()
                  
              EndSelect
              
            Case #Gadget_SnapY         
              Select EventType()
                Case #PB_EventType_Focus
                  GBFocusGadget = 1
                  RemoveShortcut()
                  
                Case #PB_EventType_Change               
                  camera\snap\Y = GetGadgetState(#Gadget_SnapY)
                  
                Case #PB_EventType_LostFocus
                  GBFocusGadget = 0
                  AddKeyboardShortcutMenu()
                  
              EndSelect
              
            Case #Gadget_SnapZ
              Select EventType()
                Case #PB_EventType_Focus
                  GBFocusGadget = 1
                  RemoveShortcut()
                  
                Case #PB_EventType_Change               
                  camera\snap\Z = GetGadgetState(#Gadget_SnapZ)
                  
                Case #PB_EventType_LostFocus
                  GBFocusGadget = 0
                  AddKeyboardShortcutMenu()
                  
              EndSelect
              
            Case #Gadget_ModeSelection   
              option\ModeSelection = GetGadgetState(#Gadget_ModeSelection)
              SetObjectSelectionMode()
              
            Case #Gadget_ShowCadreSelect
              cadre =GetGadgetState(#Gadget_ShowCadreSelect)
              HideEntity(#BoundingBox,1-cadre)
              
            Case #Gadget_DirAuto
              option\autodir = GetGadgetState(#Gadget_DirAuto)
              
              ;}
              ;{ Select
            Case #gadget_selectlist          
              n$ = GetGadgetText(#gadget_selectlist)
              ObjectSelect(n$)
              ;} 
          EndSelect
          
        ElseIf Event = #PB_Event_Menu And GBFocusGadget =0
          
          Select EventMenu()
              ;{ toolbar menu
             Case #Gadget_Snap             
              camera\snapOk = GetToolBarButtonState(#TOOLBAR,#Gadget_Snap)
              ;}
              ;{ files
            Case 0
              Quit = 1
              
            Case 2
              ClearScene()
              OpenScene()
              
            Case 1,6
              ClearScene()
              
            Case 3 ; import      
              OpenScene()
              
            Case 4,5
              SaveScene()
              
            Case 9
              ExportForGame()
              
            Case 10
              SaveScene(1)
              
              ;}
              ;{ view
            Case 41
              CheckOption(option\Grid, 41) 
              AddGrid(option\Grid)            
              
            Case 42
              CheckOption(option\Marker3D, 42)              
              AddMarker3D(option\Marker3D)    
              
            Case 43
              CheckOption(option\bbox, 43)            
              WorldDebug(option\bbox)           
              
            Case 44 To 52
              ChangeCamera(EventMenu() - 44)
              
            Case 53
              camera\color = ColorRequester(camera\color)
              CameraBackColor(#CameraGame,camera\color)
              
            Case 60            
              CheckOption(option\CameraRenderMode,60)            
              CameraRenderMode(#CameraGame,#PB_Camera_Wireframe*option\CameraRenderMode)
              ;}
              ;{ help         
            Case 81
              OpenAbout()
              
            Case 82
              OpenInfo()
              
            Case 83
              OpenPref()
              
              ;}
              ;{ bank 
            Case 121 To 121+GbObjBank; supra temporaire, car supra pourrave
              InitObj(EventMenu()-121)
              ;{ supra temporaire, car on ne peut pas ajouter indfiniment des objets par un menu, je dois crer une liste pour a
              For i=0 To GbObjBank
                SetMenuItemState(0,121+i,0)
              Next i            
              SetMenuItemState(0,EventMenu(),1)
              ;}
              ;}
              ;{ object
            Case 100 To 100+ArraySize(SceneTree())
              nom$ = InputRequester("Name","Add an element","")
              If nom$ <>""
                AddAsset(nom$,Random(500),Random(500),Random(500),EventMenu()-100)
                UpdateTreeGadget()
              EndIf
              
            Case 303
              CreateObjet()
              
            Case 304 
              AddLight(Gbcolor,Cible\pos\x,Cible\pos\y,Cible\pos\z,#White,0,0)
              
            Case 301
              AddLight(Gbcolor,Cible\pos\x,Cible\pos\y,Cible\pos\z,#White,0,1)
              
            Case 302
              AddLight(Gbcolor,Cible\pos\x,Cible\pos\y,Cible\pos\z,#White,0,2)
              
            Case 305 To 309
              TypeObjet = EventMenu()-305
              For i = 0 To 4
                SetMenuItemState(0,305+i,0)
              Next i            
              SetMenuItemState(0,EventMenu(),1)
              
            Case 318 To 321
              n=EventGadget()-318
              CreatePrimitive(n)
              
            Case 441,313 To 314
              MessageRequester("Infos","Function not Finished")
              
            Case 351
              FreezeObject(1)
              
            Case 352
              FreezeAll(1)
              
            Case 353
              FreezeAll(0)  
              
            Case 354
              DuplicatedObject()
              
            Case 355
              DeleteObjet()           
              
            Case 356
              SelectAllObject(0)
              SelectAllObject(1)
              
            Case 357
              SelectAllObject(0)
              
            Case 358
              HideObj()
              
            Case 359         
              UnhideAll()
              
              ;}
              ;{ game
            Case 441
              
            Case 442
              OpenLevelProp()
              ;}
              ;{ world
            Case 401,#toolbar_btn_light
              CheckOption(option\LightActive,401)  
              LightHide()
              SetMenuItemState(0,401,option\LightActive)
              
            Case 403 ; ambient
              OpenWorld()
              ;}
          EndSelect
          
        ElseIf event = #PB_Event_GadgetDrop ; event drop
          
          Select EventDropType()
              
            Case #PB_Drop_Private
              tItem = GetGadgetState(#Treegadget_Scene)
              If GetGadgetItemAttribute(#Treegadget_Scene,tItem,#PB_Tree_SubLevel)>0
                tText.s = GetGadgetItemText(#Treegadget_Scene, tItem)
                ForEach asset()
                  If asset()\names$ = tText                    
                    If asset()\type = sType
                      SetGadgetItemText(#Treegadget_Scene, sItem, tText)
                      SetGadgetItemText(#Treegadget_Scene, tItem, sText)
                    EndIf
                    Break
                  EndIf
                Next                
              EndIf  
              
          EndSelect
          
        ElseIf event = #PB_Event_CloseWindow
          If option\confirmExit
            If MessageRequester("Close","Close the programm ?",#PB_MessageRequester_YesNo) = 6
              Quit = 1
            EndIf
          Else
            quit = 1
          EndIf
          
        EndIf
        ;}
        
      Case #windowLevelProp
        
        Select event
            
          Case #PB_Event_CloseWindow
            WindowClose(#windowLevelProp)
            
          Case #PB_Event_Gadget
            
            Select EventGadget()
                
              Case #winLevelpropBtnOk            
                WindowClose(#windowLevelProp)
                
              Case #winLevelpropBtnCancel
                WindowClose(#windowLevelProp)
                
            EndSelect
            
        EndSelect 
        
      Case #windowInfo
        
        Select event
            
          Case #PB_Event_CloseWindow
             WindowClose(#windowInfo)                
            
          Case #PB_Event_Gadget
            
            Select EventGadget()
                
              Case #winInfoBtnOk            
               WindowClose(#windowInfo)       
                
           EndSelect
           
        EndSelect    
        
      Case #windowAbout
        
        Select event
            
          Case #PB_Event_CloseWindow
            WindowClose(#windowAbout)
            
          Case #PB_Event_Gadget
            
            Select EventGadget()
                
              Case #WinAboutBtnOk         
                WindowClose(#windowAbout)     
                
            EndSelect
            
        EndSelect    
        
      Case #windowpref
        
        Select event
            
          Case #PB_Event_CloseWindow
            WindowClose(#windowpref)
            
          Case #PB_Event_Gadget
            
            Select EventGadget()
                
              Case #Gadget_ShowCadreSelect
                cadre =GetGadgetState(#Gadget_ShowCadreSelect)
                HideEntity(#BoundingBox,1-cadre)
                
              Case #winPrefBtnOk ;ok                
                WindowClose(#windowpref)
                
              Case #winPrefBtnCancel ; cancel
                WindowClose(#windowpref)
                
              Case #winPrefCboxLang                
                lang = GetGadgetState(#winPrefCboxLang)
                Select lang 
                  Case 0
                    option\Lang$ ="fr"
                  Case 1
                    option\Lang$ ="eng"
                EndSelect 
                
              Case #winPrefCbExit
                option\confirmExit = GetGadgetState(#winPrefCbExit)
                
              Case #winPrefCbAutosize
                option\autosize = GetGadgetState(#winPrefCbAutosize)
                
              Case #winPrefCbTooltip
                option\tooltip = GetGadgetState(#winPrefCbTooltip)
                
              Case #winPrefSpTexture
                prim\TexturRepeat = GetGadgetState(#winPrefSpTexture)
                
            EndSelect
            
        EndSelect 
        
      Case #windowWorld
                
        Select event
            
          Case #PB_Event_CloseWindow
            WindowClose(#windowWorld)
            
          Case #PB_Event_Gadget
            
            Select EventGadget()
              Case #winWorldBtnAmbient            
                World\AmbientColor = ColorRequester(World\AmbientColor)
                AmbientColor(World\AmbientColor)
                ;{ Fog  
              Case #winWorldCbFogAdd
                If MessageRequester("Fog","Fog can't be desable in the scene if you choose Yes",#PB_MessageRequester_YesNo) =6
                  With world\Fog
                    Fog(\Color,\Intensity,\StarDist,\EndDist)
                  EndWith
                EndIf
                
              Case #winWorldCbFog
                World\Fog\actif = GetGadgetState(#winWorldCbFog)
                
              Case #winWorldCbFogCol
                World\Fog\Color = ColorRequester( World\Fog\Color)
                
              Case #winWorldCbFogInt
                world\Fog\Intensity = GetGadgetState(#winWorldCbFogInt)/100
                ;}
                ;{ skydom
              Case #winWorldBtnSkydomTexture; img
                file$=OpenFileRequester("Choose the texture","","Image|*.jpg;*.png;*.tga",0)
                If file$ <>""
                  world\Skydom\SkyImg$ = GetFilePart(file$)
                EndIf            
                
              Case 1021; curve
                
              Case #winWorldBtnSkydomAdd
                CreateSkydom()
                ;}
                ;{ skybox
              Case #winWorldBtnSkyboxAdd
                CreateSkyBox()
                ;}
                
            EndSelect
            
        EndSelect
        
    EndSelect
    ;UpdateInfos()
    
    If Quit = 1 : ProcedureReturn Quit : EndIf  ; Quit the app immediately
  Until Event = 0
  
;   If ExamineKeyboard()
;     If KeyboardReleased(#PB_Key_F1)
;       Screen3DRequester_ShowStats = 1-Screen3DRequester_ShowStats ; Switch the ShowStats on/off
;     EndIf
;   EndIf
  
EndProcedure
;}

; IDE Options = PureBasic 5.00 Beta 6 (Windows - x86)
; CursorPosition = 277
; Folding = BpAAAAAAAAYCAAAAAAAAAAAwDEAAAAA-
; Markers = 834
; EnableXP
; EnableOnError
; EnablePurifier