
; procedures new panel

Procedure AddPanelProperty() 
  ;{ property box
  OpenGadgetList(#PanelProperty)
  AddGadgetItem(#PanelProperty,0,"Properties")
  CloseGadgetList()
  ;}  
  ;{ infos
  OpenGadgetList(#PanelProperty)
  AddGadgetItem(#PanelProperty,-1,"Infos")
  ScrollAreaGadget(#sa_panInfo,2,5,#PanelPropertyWidth-7,#PanoObjetH-50,#PanelPropertyWidth-20,#PanoObjetH-60,5,#PB_ScrollArea_BorderLess)
  TextGadget(#gadget_Txt_info,7,10,#PanelPropertyWidth-12,#PanoObjetH-60,"")        
  CloseGadgetList() 
  CloseGadgetList() 
  ;}
EndProcedure

; macros
Macro SetGadget(gadget,h,chp,val,valmax)
  ; macro pour les gadget de type : position, rotation, scale
  For i=0 To 2
    SpinGadget(gadget+i,10+i*(3+(w-16)/3),h,(w-16)/3,20,val,valmax,#PB_Spin_Numeric)
  Next i
  SetGadgetText(gadget,Str(asset()\chp\x))
  SetGadgetText(gadget+1,Str(asset()\chp\y))
  SetGadgetText(gadget+2,Str(asset()\chp\z))     
EndMacro

; drag & drop (not used)
Procedure TreeDrag()
  item = GetGadgetState(#Treegadget_Scene)
  If GetGadgetItemAttribute(#Treegadget_Scene,item,#PB_Tree_SubLevel)>0
    DragPrivate(#Drop_Private, #PB_Drag_Move)  
  EndIf  
EndProcedure
Procedure TreeDrop()
   item = GetGadgetState(#Treegadget_Scene)
  If GetGadgetItemAttribute(#Treegadget_Scene,item,#PB_Tree_SubLevel)>0
    sText.s = GetGadgetItemText(#Treegadget_Scene, sItem)
    Text.s = GetGadgetItemText(#Treegadget_Scene, Item)
    SetGadgetItemText(#Treegadget_Scene, sItem, Text)
    SetGadgetItemText(#Treegadget_Scene, Item, sText)         
  EndIf  
EndProcedure

; property Box
Procedure PropertyBox(type=0)
  item = GetGadgetState(#Treegadget_Scene)
  If GetGadgetItemAttribute(#Treegadget_Scene,item,#PB_Tree_SubLevel)>0
    ClearGadgetItems(#PanelProperty)
    w = #PanelPropertyWidth-20
    AddPanelProperty() 
    OpenGadgetList(#PanelProperty,0)
    With asset()
      Frame3DGadget(#Property_Frame1,5,5,w,40,"General")
      StringGadget(#Property_Name,10,20,w-10,20,\names$)
      Frame3DGadget(#Property_Frame2,5,60,w,40,"Position")
      SetGadget(#Property_PosX,75,pos,-10000,10000)
      dee = 100
      ; on ajoute les generalit
      Select \type 
        Case 0,1,6,7,9,10,11,12
          Frame3DGadget(#Property_Frame3,5,100,w,40,"Rotation")
          SetGadget(#Property_RotX,115,rot,-180,180)
          Frame3DGadget(#Property_Frame4,5,140,w,40,"Scale")
          SetGadget(#Property_ScaleX,155,scale,1,1000)          
          dee = 190
          Frame3DGadget(#Property_Frame5,5,dee,w,100,"Editor")
          CheckBoxGadget(#property_cb_freeze,10,dee+15,50,15,"Freeze")
          CheckBoxGadget(#property_cb_hide,70,dee+15,40,15,"Hide")
          TextGadget(#property_id,120,dee+15,40,15,"ID : "+Str(Asset()\id),#PB_Text_Center)
          SetGadgetColor(#property_id,2,$E6E6E6)
          DisableGadget(#property_id,1)
          ComboBoxGadget(#property_comb_lookTo,10,dee+35,60,20)
          GadgetToolTip(#property_comb_lookTo,"Object Look at...")
          AddGadgetItem(#property_comb_lookTo,-1,"Object")
          AddGadgetItem(#property_comb_lookTo,-1,"Player")
          AddGadgetItem(#property_comb_lookTo,-1,"Camera")
          StringGadget(#Property_sg_LookTo,75,dee+35,70,20,"")
          GadgetToolTip(#Property_sg_LookTo,"The Cible of the 'look at'..")
          ButtonGadget(#Property_btn_LookTo,150,dee+35,20,20,"...")
          dee = 300
          Frame3DGadget(#Property_Frame6,5,dee,w,50,"Properties")
          CheckBoxGadget(#Prop_CastShado,10,dee+15,w-10,20,"Cast Shadow")
         

      EndSelect
      
      Select type
        Case 0 ; assets          
          Frame3DGadget(#Property_Frame7,5,dee,w,50,"Motion")
          
        Case 1 ; pnj
          
        Case 2,3 ; light dynamic & statics
          ;{ light 
          dee+10
          Frame3DGadget(#Property_Frame3,5,dee,w,100,"Editor")
          CheckBoxGadget(#property_cb_freeze,10,dee+15,50,15,"Freeze")
          CheckBoxGadget(#property_cb_hide,70,dee+15,50,15,"Hide")
          TextGadget(#property_id,120,dee+15,40,15,"ID : "+Str(Asset()\id),#PB_Text_Center)
          SetGadgetColor(#property_id,2,$E6E6E6)
          DisableGadget(#property_id,1)
          ComboBoxGadget(#property_comb_lookTo,10,dee+35,60,20)
          GadgetToolTip(#property_comb_lookTo,"Object Look To...")
          AddGadgetItem(#property_comb_lookTo,-1,"Object")
          AddGadgetItem(#property_comb_lookTo,-1,"Player")
          AddGadgetItem(#property_comb_lookTo,-1,"Camera")
          StringGadget(#Property_sg_LookTo,75,dee+35,70,20,"")
          ButtonGadget(#Property_btn_LookTo,150,dee+35,20,20,"...")
          dee +110
          Frame3DGadget(#Property_Frame4,5,dee,w,80,"Properties")
          StartDrawing(ImageOutput(#lightcolordif))
          Box(0,0,15,15,asset()\colDif)
          StopDrawing()
          ImageGadget(#Prop_ColDif_img,15,dee+17,15,15,ImageID(#lightcolordif),#PB_Image_Border)
          GadgetToolTip(#Prop_ColDif_img,"Diffuse Color of the light")
          ButtonGadget(#Prop_ColDif_btn,35,dee+15,20,20,"...")
          StartDrawing(ImageOutput(#lightcolordif))
          Box(0,0,15,15,asset()\colSpec)
          StopDrawing()
          ImageGadget(#Prop_ColSpec_img,65,dee+17,15,15,ImageID(#lightcolorspec),#PB_Image_Border)
          GadgetToolTip(#Prop_ColSpec_img,"Specular Color of the ight")
          ButtonGadget(#Prop_ColSpec_btn,85,dee+15,20,20,"...")
          CheckBoxGadget(#Prop_CastShado,110,dee+15,55,20,"Shadow")
          
          ComboBoxGadget(#Prop_LightType_ccb,15,dee+40,w-60,20)
          AddGadgetItem(#Prop_LightType_ccb,0,"Point Light")
          AddGadgetItem(#Prop_LightType_ccb,1,"Directionnal Light")
          AddGadgetItem(#Prop_LightType_ccb,2,"Spot Light")
          SetGadgetState(#Prop_LightType_ccb,0);}
    
        Case 4 ;effects
          
        Case 5;actions
          
        Case 6;fontain
          
        Case 7 ;Drop
          
        Case 8 ;Fx
          
        Case 9 ;Obj block
          
        Case 10 ;Obj move
          
        Case 11 ;Obj destroy
          
        Case 12 ;camera          
          FreeGadget(#Prop_CastShado) 
          Frame3DGadget(#Property_Frame6,5,dee,w,60,"Properties")
          CheckBoxGadget(#cameraMode,10,dee+15,w-10,20,"Mode Orthogonal")      
          CheckBoxGadget(#cameraLookAt,10,dee+35,w-10,20,"Look At Seleted")
          
          
      EndSelect
    EndWith
  EndIf
  UpdateInfos()
EndProcedure
Procedure UpdateTreeGadget()
  ClearGadgetItems(#Treegadget_Scene)
  pos = GetGadgetState(#Treegadget_Scene)
  For i = 0 To ArraySize(SceneTree())
    If IsImage(i)
      AddGadgetItem (#Treegadget_Scene, -1, SceneTree(i)\name$, ImageID(i),0) 
    Else
      AddGadgetItem (#Treegadget_Scene, -1, SceneTree(i)\name$, ImageID(#Assets),0) 
    EndIf    
    ForEach Asset()
      If asset()\type = i      
        AddGadgetItem(#Treegadget_Scene, pos, asset()\names$, ImageID(asset()\type), 1) 
        SetGadgetItemData(#Treegadget_Scene,CountGadgetItems(#Treegadget_Scene)-1,-1)
      EndIf    
    Next 
  Next i
EndProcedure
Procedure CheckProperty(nom$)
  ForEach Asset()
    If Asset()\names$ = nom$
      PropertyBox(Asset()\type)
      Break
    EndIf    
  Next  
EndProcedure

; ajout d'objets/assets
Procedure AddAsset(name$="",x=0,y=0,z=0,type=0)
  Level\NbEntity+1
  AddElement(asset())  
  With Asset()
    \names$ = name$
    \pos\x = x
    \pos\y = y
    \pos\z = z
    \id = Level\NbEntity
    \type = type
    If \type = 2 Or \type = 3 ; light
      \colDif = #Red
      \colSpec = #White
    EndIf    
  EndWith  
EndProcedure


; IDE Options = PureBasic 4.61 Beta 4 (Windows - x86)
; CursorPosition = 47
; Folding = EO+
; EnableXP
; EnableOnError
; EnablePurifier